// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(
	columns, fromClause, joinItems,
	whereClause interface{}, distinctClause interface{},
	count interface{}, groupByClause interface{}, orderList interface{},
	offsetClause interface{},
) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		SelectItems: columns.([]parsers.SelectItem),
	}

	if fromTable, ok := fromClause.(parsers.Table); ok {
		selectStmt.Table = fromTable
	}

	if joinItemsArray, ok := joinItems.([]interface{}); ok && len(joinItemsArray) > 0 {
		selectStmt.JoinItems = make([]parsers.JoinItem, len(joinItemsArray))
		for i, joinItem := range joinItemsArray {
			selectStmt.JoinItems[i] = joinItem.(parsers.JoinItem)
		}
	}

	switch v := whereClause.(type) {
	case parsers.ComparisonExpression, parsers.LogicalExpression, parsers.Constant, parsers.SelectItem:
		selectStmt.Filters = v
	}

	if distinctClause != nil {
		selectStmt.Distinct = true
	}

	if n, ok := count.(int); ok {
		selectStmt.Count = n
	}

	if offsetArr, ok := offsetClause.([]interface{}); ok && len(offsetArr) == 2 {
		if n, ok := offsetArr[0].(int); ok {
			selectStmt.Offset = n
		}

		if n, ok := offsetArr[1].(int); ok {
			selectStmt.Count = n
		}
	}

	if orderExpressions, ok := orderList.([]parsers.OrderExpression); ok {
		selectStmt.OrderExpressions = orderExpressions
	}

	if groupByClause != nil {
		selectStmt.GroupBy = groupByClause.([]parsers.SelectItem)
	}

	return selectStmt, nil
}

func makeJoin(table interface{}, column interface{}) (parsers.JoinItem, error) {
	joinItem := parsers.JoinItem{}

	if selectItem, isSelectItem := column.(parsers.SelectItem); isSelectItem {
		joinItem.SelectItem = selectItem
		joinItem.Table.Value = selectItem.Alias
	}

	if tableTyped, isTable := table.(parsers.Table); isTable {
		joinItem.Table = tableTyped
	}

	return joinItem, nil
}

func makeSelectItem(name interface{}, path interface{}, selectItemType parsers.SelectItemType) (parsers.SelectItem, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	return parsers.SelectItem{Path: paths, Type: selectItemType}, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.SelectItem, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.SelectItem, len(collsAsArray)+1)
	columnList[0] = column.(parsers.SelectItem)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func makeSelectArray(columns interface{}) (parsers.SelectItem, error) {
	return parsers.SelectItem{
		SelectItems: columns.([]parsers.SelectItem),
		Type:        parsers.SelectItemTypeArray,
	}, nil
}

func makeSelectObject(field interface{}, other_fields interface{}) (parsers.SelectItem, error) {
	fieldsAsArray := other_fields.([]interface{})
	fieldsList := make([]parsers.SelectItem, len(fieldsAsArray)+1)
	fieldsList[0] = field.(parsers.SelectItem)

	for i, v := range fieldsAsArray {
		if col, ok := v.(parsers.SelectItem); ok {
			fieldsList[i+1] = col
		}
	}

	return parsers.SelectItem{
		SelectItems: fieldsList,
		Type:        parsers.SelectItemTypeObject,
	}, nil
}

func makeOrderByClause(ex1 interface{}, others interface{}) ([]parsers.OrderExpression, error) {
	othersArray := others.([]interface{})
	orderList := make([]parsers.OrderExpression, len(othersArray)+1)
	orderList[0] = ex1.(parsers.OrderExpression)

	for i, v := range othersArray {
		if col, ok := v.(parsers.OrderExpression); ok {
			orderList[i+1] = col
		}
	}

	return orderList, nil
}

func makeOrderExpression(field interface{}, order interface{}) (parsers.OrderExpression, error) {
	value := parsers.OrderExpression{
		SelectItem: field.(parsers.SelectItem),
		Direction:  parsers.OrderDirectionAsc,
	}

	if orderValue, ok := order.(parsers.OrderDirection); ok {
		value.Direction = orderValue
	}

	return value, nil
}

func createFunctionCall(functionType parsers.FunctionCallType, arguments []interface{}) (parsers.FunctionCall, error) {
	return parsers.FunctionCall{Type: functionType, Arguments: arguments}, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 183, col: 1, offset: 4923},
			expr: &actionExpr{
				pos: position{line: 183, col: 10, offset: 4932},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 183, col: 10, offset: 4932},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 183, col: 21, offset: 4943},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 187, col: 1, offset: 4986},
			expr: &actionExpr{
				pos: position{line: 187, col: 15, offset: 5000},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 187, col: 15, offset: 5000},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 187, col: 15, offset: 5000},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 187, col: 22, offset: 5007},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 188, col: 5, offset: 5014},
							label: "distinctClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 188, col: 20, offset: 5029},
								expr: &ruleRefExpr{
									pos:  position{line: 188, col: 20, offset: 5029},
									name: "DistinctClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 188, col: 36, offset: 5045},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 189, col: 5, offset: 5052},
							label: "topClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 189, col: 15, offset: 5062},
								expr: &ruleRefExpr{
									pos:  position{line: 189, col: 15, offset: 5062},
									name: "TopClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 189, col: 26, offset: 5073},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 190, col: 5, offset: 5080},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 190, col: 13, offset: 5088},
								name: "Selection",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 190, col: 23, offset: 5098},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 191, col: 5, offset: 5105},
							label: "fromClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 191, col: 16, offset: 5116},
								expr: &ruleRefExpr{
									pos:  position{line: 191, col: 16, offset: 5116},
									name: "FromClause",
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 191, col: 28, offset: 5128},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 192, col: 5, offset: 5135},
							label: "joinClauses",
							expr: &zeroOrMoreExpr{
								pos: position{line: 192, col: 17, offset: 5147},
								expr: &actionExpr{
									pos: position{line: 192, col: 18, offset: 5148},
									run: (*parser).callonSelectStmt22,
									expr: &seqExpr{
										pos: position{line: 192, col: 18, offset: 5148},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 192, col: 18, offset: 5148},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 192, col: 21, offset: 5151},
												label: "join",
												expr: &ruleRefExpr{
													pos:  position{line: 192, col: 26, offset: 5156},
													name: "JoinClause",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 192, col: 60, offset: 5190},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 193, col: 5, offset: 5197},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 193, col: 17, offset: 5209},
								expr: &actionExpr{
									pos: position{line: 193, col: 18, offset: 5210},
									run: (*parser).callonSelectStmt30,
									expr: &seqExpr{
										pos: position{line: 193, col: 18, offset: 5210},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 193, col: 18, offset: 5210},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 21, offset: 5213},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 193, col: 27, offset: 5219},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 193, col: 30, offset: 5222},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 193, col: 40, offset: 5232},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 194, col: 5, offset: 5274},
							label: "groupByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 194, col: 19, offset: 5288},
								expr: &actionExpr{
									pos: position{line: 194, col: 20, offset: 5289},
									run: (*parser).callonSelectStmt39,
									expr: &seqExpr{
										pos: position{line: 194, col: 20, offset: 5289},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 194, col: 20, offset: 5289},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 23, offset: 5292},
												name: "GroupBy",
											},
											&ruleRefExpr{
												pos:  position{line: 194, col: 31, offset: 5300},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 194, col: 34, offset: 5303},
												label: "columns",
												expr: &ruleRefExpr{
													pos:  position{line: 194, col: 42, offset: 5311},
													name: "ColumnList",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 195, col: 5, offset: 5352},
							label: "orderByClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 195, col: 19, offset: 5366},
								expr: &actionExpr{
									pos: position{line: 195, col: 20, offset: 5367},
									run: (*parser).callonSelectStmt48,
									expr: &seqExpr{
										pos: position{line: 195, col: 20, offset: 5367},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 195, col: 20, offset: 5367},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 195, col: 23, offset: 5370},
												label: "order",
												expr: &ruleRefExpr{
													pos:  position{line: 195, col: 29, offset: 5376},
													name: "OrderByClause",
												},
											},
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 196, col: 5, offset: 5418},
							label: "offsetClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 196, col: 18, offset: 5431},
								expr: &actionExpr{
									pos: position{line: 196, col: 19, offset: 5432},
									run: (*parser).callonSelectStmt55,
									expr: &seqExpr{
										pos: position{line: 196, col: 19, offset: 5432},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 196, col: 19, offset: 5432},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 196, col: 22, offset: 5435},
												label: "offset",
												expr: &ruleRefExpr{
													pos:  position{line: 196, col: 29, offset: 5442},
													name: "OffsetClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DistinctClause",
			pos:  position{line: 201, col: 1, offset: 5637},
			expr: &litMatcher{
				pos:        position{line: 201, col: 19, offset: 5655},
				val:        "distinct",
				ignoreCase: true,
				want:       "\"DISTINCT\"i",
			},
		},
		{
			name: "TopClause",
			pos:  position{line: 203, col: 1, offset: 5668},
			expr: &actionExpr{
				pos: position{line: 203, col: 14, offset: 5681},
				run: (*parser).callonTopClause1,
				expr: &seqExpr{
					pos: position{line: 203, col: 14, offset: 5681},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 203, col: 14, offset: 5681},
							name: "Top",
						},
						&ruleRefExpr{
							pos:  position{line: 203, col: 18, offset: 5685},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 203, col: 21, offset: 5688},
							label: "count",
							expr: &ruleRefExpr{
								pos:  position{line: 203, col: 27, offset: 5694},
								name: "Integer",
							},
						},
					},
				},
			},
		},
		{
			name: "FromClause",
			pos:  position{line: 207, col: 1, offset: 5729},
			expr: &choiceExpr{
				pos: position{line: 207, col: 15, offset: 5743},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 207, col: 15, offset: 5743},
						run: (*parser).callonFromClause2,
						expr: &seqExpr{
							pos: position{line: 207, col: 15, offset: 5743},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 207, col: 15, offset: 5743},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 207, col: 20, offset: 5748},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 207, col: 23, offset: 5751},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 207, col: 29, offset: 5757},
										name: "TableName",
									},
								},
								&labeledExpr{
									pos:   position{line: 207, col: 39, offset: 5767},
									label: "selectItem",
									expr: &actionExpr{
										pos: position{line: 207, col: 51, offset: 5779},
										run: (*parser).callonFromClause9,
										expr: &seqExpr{
											pos: position{line: 207, col: 51, offset: 5779},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 207, col: 51, offset: 5779},
													name: "ws",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 54, offset: 5782},
													name: "In",
												},
												&ruleRefExpr{
													pos:  position{line: 207, col: 57, offset: 5785},
													name: "ws",
												},
												&labeledExpr{
													pos:   position{line: 207, col: 60, offset: 5788},
													label: "column",
													expr: &ruleRefExpr{
														pos:  position{line: 207, col: 67, offset: 5795},
														name: "SelectItem",
													},
												},
											},
										},
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 216, col: 5, offset: 6030},
						run: (*parser).callonFromClause16,
						expr: &seqExpr{
							pos: position{line: 216, col: 5, offset: 6030},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 216, col: 5, offset: 6030},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 216, col: 10, offset: 6035},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 216, col: 13, offset: 6038},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 216, col: 20, offset: 6045},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 223, col: 5, offset: 6244},
						run: (*parser).callonFromClause22,
						expr: &seqExpr{
							pos: position{line: 223, col: 5, offset: 6244},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 223, col: 5, offset: 6244},
									name: "From",
								},
								&ruleRefExpr{
									pos:  position{line: 223, col: 10, offset: 6249},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 223, col: 13, offset: 6252},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 223, col: 22, offset: 6261},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SubQuery",
			pos:  position{line: 232, col: 1, offset: 6442},
			expr: &actionExpr{
				pos: position{line: 232, col: 13, offset: 6454},
				run: (*parser).callonSubQuery1,
				expr: &seqExpr{
					pos: position{line: 232, col: 13, offset: 6454},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 232, col: 13, offset: 6454},
							label: "exists",
							expr: &zeroOrOneExpr{
								pos: position{line: 232, col: 20, offset: 6461},
								expr: &actionExpr{
									pos: position{line: 232, col: 21, offset: 6462},
									run: (*parser).callonSubQuery5,
									expr: &seqExpr{
										pos: position{line: 232, col: 21, offset: 6462},
										exprs: []any{
											&labeledExpr{
												pos:   position{line: 232, col: 21, offset: 6462},
												label: "exists",
												expr: &ruleRefExpr{
													pos:  position{line: 232, col: 28, offset: 6469},
													name: "Exists",
												},
											},
											&ruleRefExpr{
												pos:  position{line: 232, col: 35, offset: 6476},
												name: "ws",
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 232, col: 63, offset: 6504},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 67, offset: 6508},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 232, col: 70, offset: 6511},
							label: "selectStmt",
							expr: &ruleRefExpr{
								pos:  position{line: 232, col: 81, offset: 6522},
								name: "SelectStmt",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 232, col: 92, offset: 6533},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 232, col: 95, offset: 6536},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubQuerySelectItem",
			pos:  position{line: 241, col: 1, offset: 6748},
			expr: &actionExpr{
				pos: position{line: 241, col: 23, offset: 6770},
				run: (*parser).callonSubQuerySelectItem1,
				expr: &seqExpr{
					pos: position{line: 241, col: 23, offset: 6770},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 241, col: 23, offset: 6770},
							label: "subQuery",
							expr: &ruleRefExpr{
								pos:  position{line: 241, col: 32, offset: 6779},
								name: "SubQuery",
							},
						},
						&labeledExpr{
							pos:   position{line: 241, col: 41, offset: 6788},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 241, col: 50, offset: 6797},
								expr: &actionExpr{
									pos: position{line: 241, col: 51, offset: 6798},
									run: (*parser).callonSubQuerySelectItem7,
									expr: &seqExpr{
										pos: position{line: 241, col: 51, offset: 6798},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 241, col: 51, offset: 6798},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 241, col: 54, offset: 6801},
												label: "alias",
												expr: &ruleRefExpr{
													pos:  position{line: 241, col: 60, offset: 6807},
													name: "AsClause",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "JoinClause",
			pos:  position{line: 254, col: 1, offset: 7092},
			expr: &choiceExpr{
				pos: position{line: 254, col: 15, offset: 7106},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 254, col: 15, offset: 7106},
						run: (*parser).callonJoinClause2,
						expr: &seqExpr{
							pos: position{line: 254, col: 15, offset: 7106},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 254, col: 15, offset: 7106},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 20, offset: 7111},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 23, offset: 7114},
									label: "table",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 29, offset: 7120},
										name: "TableName",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 39, offset: 7130},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 42, offset: 7133},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 254, col: 45, offset: 7136},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 254, col: 48, offset: 7139},
									label: "column",
									expr: &ruleRefExpr{
										pos:  position{line: 254, col: 55, offset: 7146},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 256, col: 5, offset: 7198},
						run: (*parser).callonJoinClause13,
						expr: &seqExpr{
							pos: position{line: 256, col: 5, offset: 7198},
							exprs: []any{
								&ruleRefExpr{
									pos:  position{line: 256, col: 5, offset: 7198},
									name: "Join",
								},
								&ruleRefExpr{
									pos:  position{line: 256, col: 10, offset: 7203},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 256, col: 13, offset: 7206},
									label: "subQuery",
									expr: &ruleRefExpr{
										pos:  position{line: 256, col: 22, offset: 7215},
										name: "SubQuerySelectItem",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OffsetClause",
			pos:  position{line: 260, col: 1, offset: 7274},
			expr: &actionExpr{
				pos: position{line: 260, col: 17, offset: 7290},
				run: (*parser).callonOffsetClause1,
				expr: &seqExpr{
					pos: position{line: 260, col: 17, offset: 7290},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 260, col: 17, offset: 7290},
							name: "Offset",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 24, offset: 7297},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 27, offset: 7300},
							label: "offset",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 34, offset: 7307},
								name: "IntegerLiteral",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 49, offset: 7322},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 260, col: 52, offset: 7325},
							val:        "limit",
							ignoreCase: true,
							want:       "\"LIMIT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 260, col: 61, offset: 7334},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 260, col: 64, offset: 7337},
							label: "limit",
							expr: &ruleRefExpr{
								pos:  position{line: 260, col: 70, offset: 7343},
								name: "IntegerLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "Selection",
			pos:  position{line: 264, col: 1, offset: 7458},
			expr: &choiceExpr{
				pos: position{line: 264, col: 14, offset: 7471},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 264, col: 14, offset: 7471},
						name: "SelectValueSpec",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 32, offset: 7489},
						name: "ColumnList",
					},
					&ruleRefExpr{
						pos:  position{line: 264, col: 45, offset: 7502},
						name: "SelectAsterisk",
					},
				},
			},
		},
		{
			name: "SelectAsterisk",
			pos:  position{line: 266, col: 1, offset: 7518},
			expr: &actionExpr{
				pos: position{line: 266, col: 19, offset: 7536},
				run: (*parser).callonSelectAsterisk1,
				expr: &litMatcher{
					pos:        position{line: 266, col: 19, offset: 7536},
					val:        "*",
					ignoreCase: false,
					want:       "\"*\"",
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 272, col: 1, offset: 7731},
			expr: &actionExpr{
				pos: position{line: 272, col: 15, offset: 7745},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 272, col: 15, offset: 7745},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 272, col: 15, offset: 7745},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 272, col: 22, offset: 7752},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 272, col: 33, offset: 7763},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 272, col: 47, offset: 7777},
								expr: &actionExpr{
									pos: position{line: 272, col: 48, offset: 7778},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 272, col: 48, offset: 7778},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 272, col: 48, offset: 7778},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 272, col: 51, offset: 7781},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 272, col: 55, offset: 7785},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 272, col: 58, offset: 7788},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 272, col: 63, offset: 7793},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectValueSpec",
			pos:  position{line: 276, col: 1, offset: 7880},
			expr: &actionExpr{
				pos: position{line: 276, col: 20, offset: 7899},
				run: (*parser).callonSelectValueSpec1,
				expr: &seqExpr{
					pos: position{line: 276, col: 20, offset: 7899},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 276, col: 20, offset: 7899},
							val:        "value",
							ignoreCase: true,
							want:       "\"VALUE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 276, col: 29, offset: 7908},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 276, col: 32, offset: 7911},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 276, col: 39, offset: 7918},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 282, col: 1, offset: 8072},
			expr: &actionExpr{
				pos: position{line: 282, col: 14, offset: 8085},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 282, col: 14, offset: 8085},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 282, col: 18, offset: 8089},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "SelectArray",
			pos:  position{line: 286, col: 1, offset: 8156},
			expr: &actionExpr{
				pos: position{line: 286, col: 16, offset: 8171},
				run: (*parser).callonSelectArray1,
				expr: &seqExpr{
					pos: position{line: 286, col: 16, offset: 8171},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 286, col: 16, offset: 8171},
							val:        "[",
							ignoreCase: false,
							want:       "\"[\"",
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 20, offset: 8175},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 286, col: 23, offset: 8178},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 286, col: 31, offset: 8186},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 286, col: 42, offset: 8197},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 286, col: 45, offset: 8200},
							val:        "]",
							ignoreCase: false,
							want:       "\"]\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObject",
			pos:  position{line: 290, col: 1, offset: 8245},
			expr: &actionExpr{
				pos: position{line: 290, col: 17, offset: 8261},
				run: (*parser).callonSelectObject1,
				expr: &seqExpr{
					pos: position{line: 290, col: 17, offset: 8261},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 290, col: 17, offset: 8261},
							val:        "{",
							ignoreCase: false,
							want:       "\"{\"",
						},
						&ruleRefExpr{
							pos:  position{line: 290, col: 21, offset: 8265},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 290, col: 24, offset: 8268},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 290, col: 30, offset: 8274},
								name: "SelectObjectField",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 290, col: 48, offset: 8292},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 290, col: 51, offset: 8295},
							label: "other_fields",
							expr: &zeroOrMoreExpr{
								pos: position{line: 290, col: 64, offset: 8308},
								expr: &actionExpr{
									pos: position{line: 290, col: 65, offset: 8309},
									run: (*parser).callonSelectObject10,
									expr: &seqExpr{
										pos: position{line: 290, col: 65, offset: 8309},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 290, col: 65, offset: 8309},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 290, col: 68, offset: 8312},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 290, col: 72, offset: 8316},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 290, col: 75, offset: 8319},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 290, col: 80, offset: 8324},
													name: "SelectObjectField",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 290, col: 120, offset: 8364},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 290, col: 123, offset: 8367},
							val:        "}",
							ignoreCase: false,
							want:       "\"}\"",
						},
					},
				},
			},
		},
		{
			name: "SelectObjectField",
			pos:  position{line: 294, col: 1, offset: 8425},
			expr: &actionExpr{
				pos: position{line: 294, col: 22, offset: 8446},
				run: (*parser).callonSelectObjectField1,
				expr: &seqExpr{
					pos: position{line: 294, col: 22, offset: 8446},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 294, col: 22, offset: 8446},
							label: "name",
							expr: &choiceExpr{
								pos: position{line: 294, col: 28, offset: 8452},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 294, col: 28, offset: 8452},
										name: "Identifier",
									},
									&actionExpr{
										pos: position{line: 294, col: 41, offset: 8465},
										run: (*parser).callonSelectObjectField6,
										expr: &seqExpr{
											pos: position{line: 294, col: 41, offset: 8465},
											exprs: []any{
												&litMatcher{
													pos:        position{line: 294, col: 41, offset: 8465},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
												&labeledExpr{
													pos:   position{line: 294, col: 46, offset: 8470},
													label: "key",
													expr: &ruleRefExpr{
														pos:  position{line: 294, col: 50, offset: 8474},
														name: "Identifier",
													},
												},
												&litMatcher{
													pos:        position{line: 294, col: 61, offset: 8485},
													val:        "\"",
													ignoreCase: false,
													want:       "\"\\\"\"",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 294, col: 87, offset: 8511},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 294, col: 90, offset: 8514},
							val:        ":",
							ignoreCase: false,
							want:       "\":\"",
						},
						&ruleRefExpr{
							pos:  position{line: 294, col: 94, offset: 8518},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 294, col: 97, offset: 8521},
							label: "selectItem",
							expr: &ruleRefExpr{
								pos:  position{line: 294, col: 108, offset: 8532},
								name: "SelectItem",
							},
						},
					},
				},
			},
		},
		{
			name: "SelectProperty",
			pos:  position{line: 300, col: 1, offset: 8638},
			expr: &actionExpr{
				pos: position{line: 300, col: 19, offset: 8656},
				run: (*parser).callonSelectProperty1,
				expr: &seqExpr{
					pos: position{line: 300, col: 19, offset: 8656},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 300, col: 19, offset: 8656},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 300, col: 24, offset: 8661},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 300, col: 35, offset: 8672},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 300, col: 40, offset: 8677},
								expr: &choiceExpr{
									pos: position{line: 300, col: 41, offset: 8678},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 300, col: 41, offset: 8678},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 300, col: 58, offset: 8695},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "SelectItem",
			pos:  position{line: 304, col: 1, offset: 8786},
			expr: &actionExpr{
				pos: position{line: 304, col: 15, offset: 8800},
				run: (*parser).callonSelectItem1,
				expr: &seqExpr{
					pos: position{line: 304, col: 15, offset: 8800},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 304, col: 15, offset: 8800},
							label: "selectItem",
							expr: &choiceExpr{
								pos: position{line: 304, col: 27, offset: 8812},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 304, col: 27, offset: 8812},
										name: "SubQuerySelectItem",
									},
									&ruleRefExpr{
										pos:  position{line: 304, col: 48, offset: 8833},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 304, col: 58, offset: 8843},
										name: "FunctionCall",
									},
									&ruleRefExpr{
										pos:  position{line: 304, col: 73, offset: 8858},
										name: "SelectArray",
									},
									&ruleRefExpr{
										pos:  position{line: 304, col: 87, offset: 8872},
										name: "SelectObject",
									},
									&ruleRefExpr{
										pos:  position{line: 304, col: 102, offset: 8887},
										name: "SelectProperty",
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 304, col: 118, offset: 8903},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 304, col: 127, offset: 8912},
								expr: &ruleRefExpr{
									pos:  position{line: 304, col: 127, offset: 8912},
									name: "AsClause",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AsClause",
			pos:  position{line: 328, col: 1, offset: 9510},
			expr: &actionExpr{
				pos: position{line: 328, col: 13, offset: 9522},
				run: (*parser).callonAsClause1,
				expr: &seqExpr{
					pos: position{line: 328, col: 13, offset: 9522},
					exprs: []any{
						&zeroOrOneExpr{
							pos: position{line: 328, col: 13, offset: 9522},
							expr: &seqExpr{
								pos: position{line: 328, col: 14, offset: 9523},
								exprs: []any{
									&ruleRefExpr{
										pos:  position{line: 328, col: 14, offset: 9523},
										name: "ws",
									},
									&ruleRefExpr{
										pos:  position{line: 328, col: 17, offset: 9526},
										name: "As",
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 328, col: 22, offset: 9531},
							name: "ws",
						},
						&notExpr{
							pos: position{line: 328, col: 25, offset: 9534},
							expr: &ruleRefExpr{
								pos:  position{line: 328, col: 26, offset: 9535},
								name: "ExcludedKeywords",
							},
						},
						&labeledExpr{
							pos:   position{line: 328, col: 43, offset: 9552},
							label: "alias",
							expr: &ruleRefExpr{
								pos:  position{line: 328, col: 49, offset: 9558},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ExcludedKeywords",
			pos:  position{line: 332, col: 1, offset: 9596},
			expr: &choiceExpr{
				pos: position{line: 332, col: 21, offset: 9616},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 332, col: 21, offset: 9616},
						name: "Select",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 30, offset: 9625},
						name: "Top",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 36, offset: 9631},
						name: "As",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 41, offset: 9636},
						name: "From",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 48, offset: 9643},
						name: "In",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 53, offset: 9648},
						name: "Join",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 60, offset: 9655},
						name: "Exists",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 69, offset: 9664},
						name: "Where",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 77, offset: 9672},
						name: "And",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 83, offset: 9678},
						name: "Or",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 88, offset: 9683},
						name: "Not",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 94, offset: 9689},
						name: "GroupBy",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 104, offset: 9699},
						name: "OrderBy",
					},
					&ruleRefExpr{
						pos:  position{line: 332, col: 114, offset: 9709},
						name: "Offset",
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 334, col: 1, offset: 9717},
			expr: &actionExpr{
				pos: position{line: 334, col: 19, offset: 9735},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 334, col: 19, offset: 9735},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 334, col: 19, offset: 9735},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 334, col: 23, offset: 9739},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 334, col: 26, offset: 9742},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 338, col: 1, offset: 9777},
			expr: &choiceExpr{
				pos: position{line: 338, col: 21, offset: 9797},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 338, col: 21, offset: 9797},
						run: (*parser).callonArrayFieldAccess2,
						expr: &seqExpr{
							pos: position{line: 338, col: 21, offset: 9797},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 338, col: 21, offset: 9797},
									val:        "[\"",
									ignoreCase: false,
									want:       "\"[\\\"\"",
								},
								&labeledExpr{
									pos:   position{line: 338, col: 27, offset: 9803},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 338, col: 30, offset: 9806},
										name: "Identifier",
									},
								},
								&litMatcher{
									pos:        position{line: 338, col: 41, offset: 9817},
									val:        "\"]",
									ignoreCase: false,
									want:       "\"\\\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 339, col: 5, offset: 9846},
						run: (*parser).callonArrayFieldAccess8,
						expr: &seqExpr{
							pos: position{line: 339, col: 5, offset: 9846},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 339, col: 5, offset: 9846},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 339, col: 9, offset: 9850},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 339, col: 12, offset: 9853},
										name: "Integer",
									},
								},
								&litMatcher{
									pos:        position{line: 339, col: 20, offset: 9861},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 340, col: 5, offset: 9908},
						run: (*parser).callonArrayFieldAccess14,
						expr: &seqExpr{
							pos: position{line: 340, col: 5, offset: 9908},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 340, col: 5, offset: 9908},
									val:        "[",
									ignoreCase: false,
									want:       "\"[\"",
								},
								&labeledExpr{
									pos:   position{line: 340, col: 9, offset: 9912},
									label: "id",
									expr: &ruleRefExpr{
										pos:  position{line: 340, col: 12, offset: 9915},
										name: "ParameterConstant",
									},
								},
								&litMatcher{
									pos:        position{line: 340, col: 30, offset: 9933},
									val:        "]",
									ignoreCase: false,
									want:       "\"]\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 342, col: 1, offset: 9991},
			expr: &actionExpr{
				pos: position{line: 342, col: 15, offset: 10005},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 342, col: 15, offset: 10005},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 342, col: 15, offset: 10005},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 342, col: 24, offset: 10014},
							expr: &charClassMatcher{
								pos:        position{line: 342, col: 24, offset: 10014},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 346, col: 1, offset: 10064},
			expr: &actionExpr{
				pos: position{line: 346, col: 14, offset: 10077},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 346, col: 14, offset: 10077},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 346, col: 25, offset: 10088},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 350, col: 1, offset: 10133},
			expr: &actionExpr{
				pos: position{line: 350, col: 17, offset: 10149},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 350, col: 17, offset: 10149},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 350, col: 17, offset: 10149},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 350, col: 21, offset: 10153},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 350, col: 35, offset: 10167},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 350, col: 39, offset: 10171},
								expr: &actionExpr{
									pos: position{line: 350, col: 40, offset: 10172},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 350, col: 40, offset: 10172},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 350, col: 40, offset: 10172},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 350, col: 43, offset: 10175},
												name: "Or",
											},
											&ruleRefExpr{
												pos:  position{line: 350, col: 46, offset: 10178},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 350, col: 49, offset: 10181},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 350, col: 52, offset: 10184},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 354, col: 1, offset: 10297},
			expr: &actionExpr{
				pos: position{line: 354, col: 18, offset: 10314},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 354, col: 18, offset: 10314},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 354, col: 18, offset: 10314},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 354, col: 22, offset: 10318},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 354, col: 43, offset: 10339},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 354, col: 47, offset: 10343},
								expr: &actionExpr{
									pos: position{line: 354, col: 48, offset: 10344},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 354, col: 48, offset: 10344},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 354, col: 48, offset: 10344},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 354, col: 51, offset: 10347},
												name: "And",
											},
											&ruleRefExpr{
												pos:  position{line: 354, col: 55, offset: 10351},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 354, col: 58, offset: 10354},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 354, col: 61, offset: 10357},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 358, col: 1, offset: 10478},
			expr: &choiceExpr{
				pos: position{line: 358, col: 25, offset: 10502},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 358, col: 25, offset: 10502},
						run: (*parser).callonComparisonExpression2,
						expr: &seqExpr{
							pos: position{line: 358, col: 25, offset: 10502},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 358, col: 25, offset: 10502},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 358, col: 29, offset: 10506},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 358, col: 32, offset: 10509},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 358, col: 35, offset: 10512},
										name: "OrExpression",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 358, col: 48, offset: 10525},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 358, col: 51, offset: 10528},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 359, col: 7, offset: 10557},
						run: (*parser).callonComparisonExpression10,
						expr: &seqExpr{
							pos: position{line: 359, col: 7, offset: 10557},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 359, col: 7, offset: 10557},
									label: "left",
									expr: &ruleRefExpr{
										pos:  position{line: 359, col: 12, offset: 10562},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 359, col: 23, offset: 10573},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 359, col: 26, offset: 10576},
									label: "op",
									expr: &ruleRefExpr{
										pos:  position{line: 359, col: 29, offset: 10579},
										name: "ComparisonOperator",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 359, col: 48, offset: 10598},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 359, col: 51, offset: 10601},
									label: "right",
									expr: &ruleRefExpr{
										pos:  position{line: 359, col: 57, offset: 10607},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 361, col: 5, offset: 10714},
						run: (*parser).callonComparisonExpression20,
						expr: &seqExpr{
							pos: position{line: 361, col: 5, offset: 10714},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 361, col: 5, offset: 10714},
									label: "inv",
									expr: &zeroOrOneExpr{
										pos: position{line: 361, col: 9, offset: 10718},
										expr: &seqExpr{
											pos: position{line: 361, col: 10, offset: 10719},
											exprs: []any{
												&ruleRefExpr{
													pos:  position{line: 361, col: 10, offset: 10719},
													name: "Not",
												},
												&ruleRefExpr{
													pos:  position{line: 361, col: 14, offset: 10723},
													name: "ws",
												},
											},
										},
									},
								},
								&labeledExpr{
									pos:   position{line: 361, col: 19, offset: 10728},
									label: "ex",
									expr: &ruleRefExpr{
										pos:  position{line: 361, col: 22, offset: 10731},
										name: "SelectItem",
									},
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 368, col: 5, offset: 10861},
						run: (*parser).callonComparisonExpression29,
						expr: &labeledExpr{
							pos:   position{line: 368, col: 5, offset: 10861},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 368, col: 8, offset: 10864},
								name: "BooleanLiteral",
							},
						},
					},
				},
			},
		},
		{
			name: "OrderByClause",
			pos:  position{line: 370, col: 1, offset: 10899},
			expr: &actionExpr{
				pos: position{line: 370, col: 18, offset: 10916},
				run: (*parser).callonOrderByClause1,
				expr: &seqExpr{
					pos: position{line: 370, col: 18, offset: 10916},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 370, col: 18, offset: 10916},
							name: "OrderBy",
						},
						&ruleRefExpr{
							pos:  position{line: 370, col: 26, offset: 10924},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 370, col: 29, offset: 10927},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 370, col: 33, offset: 10931},
								name: "OrderExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 370, col: 49, offset: 10947},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 370, col: 56, offset: 10954},
								expr: &actionExpr{
									pos: position{line: 370, col: 57, offset: 10955},
									run: (*parser).callonOrderByClause9,
									expr: &seqExpr{
										pos: position{line: 370, col: 57, offset: 10955},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 370, col: 57, offset: 10955},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 370, col: 60, offset: 10958},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 370, col: 64, offset: 10962},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 370, col: 67, offset: 10965},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 370, col: 70, offset: 10968},
													name: "OrderExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderExpression",
			pos:  position{line: 374, col: 1, offset: 11052},
			expr: &actionExpr{
				pos: position{line: 374, col: 20, offset: 11071},
				run: (*parser).callonOrderExpression1,
				expr: &seqExpr{
					pos: position{line: 374, col: 20, offset: 11071},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 374, col: 20, offset: 11071},
							label: "field",
							expr: &ruleRefExpr{
								pos:  position{line: 374, col: 26, offset: 11077},
								name: "SelectProperty",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 374, col: 41, offset: 11092},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 374, col: 44, offset: 11095},
							label: "order",
							expr: &zeroOrOneExpr{
								pos: position{line: 374, col: 50, offset: 11101},
								expr: &ruleRefExpr{
									pos:  position{line: 374, col: 50, offset: 11101},
									name: "OrderDirection",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "OrderDirection",
			pos:  position{line: 378, col: 1, offset: 11167},
			expr: &actionExpr{
				pos: position{line: 378, col: 19, offset: 11185},
				run: (*parser).callonOrderDirection1,
				expr: &choiceExpr{
					pos: position{line: 378, col: 20, offset: 11186},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 378, col: 20, offset: 11186},
							val:        "asc",
							ignoreCase: true,
							want:       "\"ASC\"i",
						},
						&litMatcher{
							pos:        position{line: 378, col: 29, offset: 11195},
							val:        "desc",
							ignoreCase: true,
							want:       "\"DESC\"i",
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 386, col: 1, offset: 11347},
			expr: &litMatcher{
				pos:        position{line: 386, col: 11, offset: 11357},
				val:        "select",
				ignoreCase: true,
				want:       "\"SELECT\"i",
			},
		},
		{
			name: "Top",
			pos:  position{line: 388, col: 1, offset: 11368},
			expr: &litMatcher{
				pos:        position{line: 388, col: 8, offset: 11375},
				val:        "top",
				ignoreCase: true,
				want:       "\"TOP\"i",
			},
		},
		{
			name: "As",
			pos:  position{line: 390, col: 1, offset: 11383},
			expr: &litMatcher{
				pos:        position{line: 390, col: 7, offset: 11389},
				val:        "as",
				ignoreCase: true,
				want:       "\"AS\"i",
			},
		},
		{
			name: "From",
			pos:  position{line: 392, col: 1, offset: 11396},
			expr: &litMatcher{
				pos:        position{line: 392, col: 9, offset: 11404},
				val:        "from",
				ignoreCase: true,
				want:       "\"FROM\"i",
			},
		},
		{
			name: "In",
			pos:  position{line: 394, col: 1, offset: 11413},
			expr: &litMatcher{
				pos:        position{line: 394, col: 7, offset: 11419},
				val:        "in",
				ignoreCase: true,
				want:       "\"IN\"i",
			},
		},
		{
			name: "Join",
			pos:  position{line: 396, col: 1, offset: 11426},
			expr: &litMatcher{
				pos:        position{line: 396, col: 9, offset: 11434},
				val:        "join",
				ignoreCase: true,
				want:       "\"JOIN\"i",
			},
		},
		{
			name: "Exists",
			pos:  position{line: 398, col: 1, offset: 11443},
			expr: &litMatcher{
				pos:        position{line: 398, col: 11, offset: 11453},
				val:        "exists",
				ignoreCase: true,
				want:       "\"EXISTS\"i",
			},
		},
		{
			name: "Where",
			pos:  position{line: 400, col: 1, offset: 11464},
			expr: &litMatcher{
				pos:        position{line: 400, col: 10, offset: 11473},
				val:        "where",
				ignoreCase: true,
				want:       "\"WHERE\"i",
			},
		},
		{
			name: "And",
			pos:  position{line: 402, col: 1, offset: 11483},
			expr: &litMatcher{
				pos:        position{line: 402, col: 8, offset: 11490},
				val:        "and",
				ignoreCase: true,
				want:       "\"AND\"i",
			},
		},
		{
			name: "Or",
			pos:  position{line: 404, col: 1, offset: 11498},
			expr: &seqExpr{
				pos: position{line: 404, col: 7, offset: 11504},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 404, col: 7, offset: 11504},
						val:        "or",
						ignoreCase: true,
						want:       "\"OR\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 404, col: 13, offset: 11510},
						name: "wss",
					},
				},
			},
		},
		{
			name: "Not",
			pos:  position{line: 406, col: 1, offset: 11515},
			expr: &litMatcher{
				pos:        position{line: 406, col: 8, offset: 11522},
				val:        "not",
				ignoreCase: true,
				want:       "\"NOT\"i",
			},
		},
		{
			name: "GroupBy",
			pos:  position{line: 408, col: 1, offset: 11530},
			expr: &seqExpr{
				pos: position{line: 408, col: 12, offset: 11541},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 408, col: 12, offset: 11541},
						val:        "group",
						ignoreCase: true,
						want:       "\"GROUP\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 408, col: 21, offset: 11550},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 408, col: 24, offset: 11553},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "OrderBy",
			pos:  position{line: 410, col: 1, offset: 11560},
			expr: &seqExpr{
				pos: position{line: 410, col: 12, offset: 11571},
				exprs: []any{
					&litMatcher{
						pos:        position{line: 410, col: 12, offset: 11571},
						val:        "order",
						ignoreCase: true,
						want:       "\"ORDER\"i",
					},
					&ruleRefExpr{
						pos:  position{line: 410, col: 21, offset: 11580},
						name: "ws",
					},
					&litMatcher{
						pos:        position{line: 410, col: 24, offset: 11583},
						val:        "by",
						ignoreCase: true,
						want:       "\"BY\"i",
					},
				},
			},
		},
		{
			name: "Offset",
			pos:  position{line: 412, col: 1, offset: 11590},
			expr: &litMatcher{
				pos:        position{line: 412, col: 11, offset: 11600},
				val:        "offset",
				ignoreCase: true,
				want:       "\"OFFSET\"i",
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 414, col: 1, offset: 11611},
			expr: &actionExpr{
				pos: position{line: 414, col: 23, offset: 11633},
				run: (*parser).callonComparisonOperator1,
				expr: &choiceExpr{
					pos: position{line: 414, col: 24, offset: 11634},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 414, col: 24, offset: 11634},
							val:        "<=",
							ignoreCase: false,
							want:       "\"<=\"",
						},
						&litMatcher{
							pos:        position{line: 414, col: 31, offset: 11641},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
						&litMatcher{
							pos:        position{line: 414, col: 38, offset: 11648},
							val:        "=",
							ignoreCase: false,
							want:       "\"=\"",
						},
						&litMatcher{
							pos:        position{line: 414, col: 44, offset: 11654},
							val:        "!=",
							ignoreCase: false,
							want:       "\"!=\"",
						},
						&litMatcher{
							pos:        position{line: 414, col: 51, offset: 11661},
							val:        "<",
							ignoreCase: false,
							want:       "\"<\"",
						},
						&litMatcher{
							pos:        position{line: 414, col: 57, offset: 11667},
							val:        ">",
							ignoreCase: false,
							want:       "\">\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 418, col: 1, offset: 11708},
			expr: &choiceExpr{
				pos: position{line: 418, col: 12, offset: 11719},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 418, col: 12, offset: 11719},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 27, offset: 11734},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 44, offset: 11751},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 60, offset: 11767},
						name: "BooleanLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 77, offset: 11784},
						name: "ParameterConstant",
					},
					&ruleRefExpr{
						pos:  position{line: 418, col: 97, offset: 11804},
						name: "NullConstant",
					},
				},
			},
		},
		{
			name: "ParameterConstant",
			pos:  position{line: 420, col: 1, offset: 11818},
			expr: &actionExpr{
				pos: position{line: 420, col: 22, offset: 11839},
				run: (*parser).callonParameterConstant1,
				expr: &seqExpr{
					pos: position{line: 420, col: 22, offset: 11839},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 420, col: 22, offset: 11839},
							val:        "@",
							ignoreCase: false,
							want:       "\"@\"",
						},
						&ruleRefExpr{
							pos:  position{line: 420, col: 26, offset: 11843},
							name: "Identifier",
						},
					},
				},
			},
		},
		{
			name: "NullConstant",
			pos:  position{line: 423, col: 1, offset: 11959},
			expr: &actionExpr{
				pos: position{line: 423, col: 17, offset: 11975},
				run: (*parser).callonNullConstant1,
				expr: &litMatcher{
					pos:        position{line: 423, col: 17, offset: 11975},
					val:        "null",
					ignoreCase: true,
					want:       "\"null\"i",
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 427, col: 1, offset: 12033},
			expr: &actionExpr{
				pos: position{line: 427, col: 19, offset: 12051},
				run: (*parser).callonIntegerLiteral1,
				expr: &labeledExpr{
					pos:   position{line: 427, col: 19, offset: 12051},
					label: "number",
					expr: &ruleRefExpr{
						pos:  position{line: 427, col: 26, offset: 12058},
						name: "Integer",
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 430, col: 1, offset: 12159},
			expr: &actionExpr{
				pos: position{line: 430, col: 18, offset: 12176},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 430, col: 18, offset: 12176},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 430, col: 18, offset: 12176},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 430, col: 23, offset: 12181},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 430, col: 29, offset: 12187},
								expr: &ruleRefExpr{
									pos:  position{line: 430, col: 29, offset: 12187},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 430, col: 46, offset: 12204},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 433, col: 1, offset: 12322},
			expr: &actionExpr{
				pos: position{line: 433, col: 17, offset: 12338},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 433, col: 17, offset: 12338},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 433, col: 17, offset: 12338},
							expr: &charClassMatcher{
								pos:        position{line: 433, col: 17, offset: 12338},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 433, col: 23, offset: 12344},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 433, col: 26, offset: 12347},
							expr: &charClassMatcher{
								pos:        position{line: 433, col: 26, offset: 12347},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 437, col: 1, offset: 12503},
			expr: &actionExpr{
				pos: position{line: 437, col: 19, offset: 12521},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 437, col: 20, offset: 12522},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 437, col: 20, offset: 12522},
							val:        "true",
							ignoreCase: true,
							want:       "\"true\"i",
						},
						&litMatcher{
							pos:        position{line: 437, col: 30, offset: 12532},
							val:        "false",
							ignoreCase: true,
							want:       "\"false\"i",
						},
					},
				},
			},
		},
		{
			name: "FunctionCall",
			pos:  position{line: 442, col: 1, offset: 12687},
			expr: &choiceExpr{
				pos: position{line: 442, col: 17, offset: 12703},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 442, col: 17, offset: 12703},
						name: "StringFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 443, col: 7, offset: 12725},
						name: "TypeCheckingFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 444, col: 7, offset: 12753},
						name: "ArrayFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 445, col: 7, offset: 12774},
						name: "InFunction",
					},
					&ruleRefExpr{
						pos:  position{line: 446, col: 7, offset: 12791},
						name: "AggregateFunctions",
					},
					&ruleRefExpr{
						pos:  position{line: 447, col: 7, offset: 12816},
						name: "MathFunctions",
					},
				},
			},
		},
		{
			name: "StringFunctions",
			pos:  position{line: 449, col: 1, offset: 12831},
			expr: &choiceExpr{
				pos: position{line: 449, col: 20, offset: 12850},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 449, col: 20, offset: 12850},
						name: "StringEqualsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 450, col: 7, offset: 12879},
						name: "ToStringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 451, col: 7, offset: 12904},
						name: "ConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 452, col: 7, offset: 12927},
						name: "ThreeArgumentStringFunctionExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 453, col: 7, offset: 12971},
						name: "UpperExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 454, col: 7, offset: 12993},
						name: "LowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 455, col: 7, offset: 13015},
						name: "LeftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 456, col: 7, offset: 13036},
						name: "LengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 457, col: 7, offset: 13059},
						name: "LTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 458, col: 7, offset: 13081},
						name: "ReplaceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 459, col: 7, offset: 13105},
						name: "ReplicateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 460, col: 7, offset: 13131},
						name: "ReverseExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 461, col: 7, offset: 13155},
						name: "RightExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 462, col: 7, offset: 13177},
						name: "RTrimExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 463, col: 7, offset: 13199},
						name: "SubstringExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 464, col: 7, offset: 13225},
						name: "TrimExpression",
					},
				},
			},
		},
		{
			name: "TypeCheckingFunctions",
			pos:  position{line: 466, col: 1, offset: 13241},
			expr: &choiceExpr{
				pos: position{line: 466, col: 26, offset: 13266},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 466, col: 26, offset: 13266},
						name: "IsDefined",
					},
					&ruleRefExpr{
						pos:  position{line: 467, col: 7, offset: 13282},
						name: "IsArray",
					},
					&ruleRefExpr{
						pos:  position{line: 468, col: 7, offset: 13296},
						name: "IsBool",
					},
					&ruleRefExpr{
						pos:  position{line: 469, col: 7, offset: 13309},
						name: "IsFiniteNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 470, col: 7, offset: 13330},
						name: "IsInteger",
					},
					&ruleRefExpr{
						pos:  position{line: 471, col: 7, offset: 13346},
						name: "IsNull",
					},
					&ruleRefExpr{
						pos:  position{line: 472, col: 7, offset: 13359},
						name: "IsNumber",
					},
					&ruleRefExpr{
						pos:  position{line: 473, col: 7, offset: 13374},
						name: "IsObject",
					},
					&ruleRefExpr{
						pos:  position{line: 474, col: 7, offset: 13389},
						name: "IsPrimitive",
					},
					&ruleRefExpr{
						pos:  position{line: 475, col: 7, offset: 13407},
						name: "IsString",
					},
				},
			},
		},
		{
			name: "AggregateFunctions",
			pos:  position{line: 477, col: 1, offset: 13417},
			expr: &choiceExpr{
				pos: position{line: 477, col: 23, offset: 13439},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 477, col: 23, offset: 13439},
						name: "AvgAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 478, col: 7, offset: 13468},
						name: "CountAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 479, col: 7, offset: 13499},
						name: "MaxAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 480, col: 7, offset: 13528},
						name: "MinAggregateExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 481, col: 7, offset: 13557},
						name: "SumAggregateExpression",
					},
				},
			},
		},
		{
			name: "ArrayFunctions",
			pos:  position{line: 483, col: 1, offset: 13581},
			expr: &choiceExpr{
				pos: position{line: 483, col: 19, offset: 13599},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 483, col: 19, offset: 13599},
						name: "ArrayConcatExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 484, col: 7, offset: 13627},
						name: "ArrayContainsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 485, col: 7, offset: 13657},
						name: "ArrayContainsAnyExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 486, col: 7, offset: 13690},
						name: "ArrayContainsAllExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 487, col: 7, offset: 13723},
						name: "ArrayLengthExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 488, col: 7, offset: 13751},
						name: "ArraySliceExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 489, col: 7, offset: 13778},
						name: "SetIntersectExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 490, col: 7, offset: 13807},
						name: "SetUnionExpression",
					},
				},
			},
		},
		{
			name: "MathFunctions",
			pos:  position{line: 492, col: 1, offset: 13827},
			expr: &choiceExpr{
				pos: position{line: 492, col: 18, offset: 13844},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 492, col: 18, offset: 13844},
						name: "MathAbsExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 493, col: 7, offset: 13868},
						name: "MathAcosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 494, col: 7, offset: 13893},
						name: "MathAsinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 495, col: 7, offset: 13918},
						name: "MathAtanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 496, col: 7, offset: 13943},
						name: "MathCeilingExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 497, col: 7, offset: 13971},
						name: "MathCosExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 498, col: 7, offset: 13995},
						name: "MathCotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 499, col: 7, offset: 14019},
						name: "MathDegreesExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 500, col: 7, offset: 14047},
						name: "MathExpExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 501, col: 7, offset: 14071},
						name: "MathFloorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 502, col: 7, offset: 14097},
						name: "MathIntBitNotExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 503, col: 7, offset: 14127},
						name: "MathLog10Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 504, col: 7, offset: 14153},
						name: "MathRadiansExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 505, col: 7, offset: 14181},
						name: "MathRoundExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 506, col: 7, offset: 14207},
						name: "MathSignExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 507, col: 7, offset: 14232},
						name: "MathSinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 508, col: 7, offset: 14256},
						name: "MathSqrtExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 509, col: 7, offset: 14281},
						name: "MathSquareExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 510, col: 7, offset: 14308},
						name: "MathTanExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 511, col: 7, offset: 14332},
						name: "MathTruncExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 512, col: 7, offset: 14358},
						name: "MathAtn2Expression",
					},
					&ruleRefExpr{
						pos:  position{line: 513, col: 7, offset: 14383},
						name: "MathIntAddExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 514, col: 7, offset: 14410},
						name: "MathIntBitAndExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 515, col: 7, offset: 14440},
						name: "MathIntBitLeftShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 516, col: 7, offset: 14476},
						name: "MathIntBitOrExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 517, col: 7, offset: 14505},
						name: "MathIntBitRightShiftExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 518, col: 7, offset: 14542},
						name: "MathIntBitXorExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 519, col: 7, offset: 14572},
						name: "MathIntDivExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 520, col: 7, offset: 14599},
						name: "MathIntModExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 521, col: 7, offset: 14626},
						name: "MathIntMulExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 522, col: 7, offset: 14653},
						name: "MathIntSubExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 523, col: 7, offset: 14680},
						name: "MathPowerExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 524, col: 7, offset: 14706},
						name: "MathLogExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 525, col: 7, offset: 14730},
						name: "MathNumberBinExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 526, col: 7, offset: 14760},
						name: "MathPiExpression",
					},
					&ruleRefExpr{
						pos:  position{line: 527, col: 7, offset: 14783},
						name: "MathRandExpression",
					},
				},
			},
		},
		{
			name: "UpperExpression",
			pos:  position{line: 529, col: 1, offset: 14803},
			expr: &actionExpr{
				pos: position{line: 529, col: 20, offset: 14822},
				run: (*parser).callonUpperExpression1,
				expr: &seqExpr{
					pos: position{line: 529, col: 20, offset: 14822},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 529, col: 20, offset: 14822},
							val:        "upper",
							ignoreCase: true,
							want:       "\"UPPER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 529, col: 29, offset: 14831},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 529, col: 32, offset: 14834},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 529, col: 36, offset: 14838},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 529, col: 39, offset: 14841},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 529, col: 50, offset: 14852},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LowerExpression",
			pos:  position{line: 533, col: 1, offset: 14937},
			expr: &actionExpr{
				pos: position{line: 533, col: 20, offset: 14956},
				run: (*parser).callonLowerExpression1,
				expr: &seqExpr{
					pos: position{line: 533, col: 20, offset: 14956},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 533, col: 20, offset: 14956},
							val:        "lower",
							ignoreCase: true,
							want:       "\"LOWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 533, col: 29, offset: 14965},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 533, col: 32, offset: 14968},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&labeledExpr{
							pos:   position{line: 533, col: 36, offset: 14972},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 533, col: 39, offset: 14975},
								name: "SelectItem",
							},
						},
						&litMatcher{
							pos:        position{line: 533, col: 50, offset: 14986},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "StringEqualsExpression",
			pos:  position{line: 537, col: 1, offset: 15071},
			expr: &actionExpr{
				pos: position{line: 537, col: 27, offset: 15097},
				run: (*parser).callonStringEqualsExpression1,
				expr: &seqExpr{
					pos: position{line: 537, col: 27, offset: 15097},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 537, col: 27, offset: 15097},
							val:        "stringequals",
							ignoreCase: true,
							want:       "\"STRINGEQUALS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 43, offset: 15113},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 537, col: 46, offset: 15116},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 50, offset: 15120},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 537, col: 53, offset: 15123},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 537, col: 57, offset: 15127},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 68, offset: 15138},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 537, col: 71, offset: 15141},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 75, offset: 15145},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 537, col: 78, offset: 15148},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 537, col: 82, offset: 15152},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 537, col: 93, offset: 15163},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 537, col: 96, offset: 15166},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 537, col: 107, offset: 15177},
								expr: &actionExpr{
									pos: position{line: 537, col: 108, offset: 15178},
									run: (*parser).callonStringEqualsExpression17,
									expr: &seqExpr{
										pos: position{line: 537, col: 108, offset: 15178},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 537, col: 108, offset: 15178},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 537, col: 112, offset: 15182},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 537, col: 115, offset: 15185},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 537, col: 123, offset: 15193},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 537, col: 160, offset: 15230},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ToStringExpression",
			pos:  position{line: 541, col: 1, offset: 15340},
			expr: &actionExpr{
				pos: position{line: 541, col: 23, offset: 15362},
				run: (*parser).callonToStringExpression1,
				expr: &seqExpr{
					pos: position{line: 541, col: 23, offset: 15362},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 541, col: 23, offset: 15362},
							val:        "tostring",
							ignoreCase: true,
							want:       "\"TOSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 541, col: 35, offset: 15374},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 541, col: 38, offset: 15377},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 541, col: 42, offset: 15381},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 541, col: 45, offset: 15384},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 541, col: 48, offset: 15387},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 541, col: 59, offset: 15398},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 541, col: 62, offset: 15401},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ConcatExpression",
			pos:  position{line: 545, col: 1, offset: 15489},
			expr: &actionExpr{
				pos: position{line: 545, col: 21, offset: 15509},
				run: (*parser).callonConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 545, col: 21, offset: 15509},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 545, col: 21, offset: 15509},
							val:        "concat",
							ignoreCase: true,
							want:       "\"CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 31, offset: 15519},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 545, col: 34, offset: 15522},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 38, offset: 15526},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 545, col: 41, offset: 15529},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 545, col: 45, offset: 15533},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 545, col: 56, offset: 15544},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 545, col: 63, offset: 15551},
								expr: &actionExpr{
									pos: position{line: 545, col: 64, offset: 15552},
									run: (*parser).callonConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 545, col: 64, offset: 15552},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 545, col: 64, offset: 15552},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 545, col: 67, offset: 15555},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 545, col: 71, offset: 15559},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 545, col: 74, offset: 15562},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 545, col: 77, offset: 15565},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 545, col: 109, offset: 15597},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 545, col: 112, offset: 15600},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LeftExpression",
			pos:  position{line: 550, col: 1, offset: 15749},
			expr: &actionExpr{
				pos: position{line: 550, col: 19, offset: 15767},
				run: (*parser).callonLeftExpression1,
				expr: &seqExpr{
					pos: position{line: 550, col: 19, offset: 15767},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 550, col: 19, offset: 15767},
							val:        "left",
							ignoreCase: true,
							want:       "\"LEFT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 27, offset: 15775},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 550, col: 30, offset: 15778},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 34, offset: 15782},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 550, col: 37, offset: 15785},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 550, col: 40, offset: 15788},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 51, offset: 15799},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 550, col: 54, offset: 15802},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 58, offset: 15806},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 550, col: 61, offset: 15809},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 550, col: 68, offset: 15816},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 550, col: 79, offset: 15827},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 550, col: 82, offset: 15830},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LengthExpression",
			pos:  position{line: 554, col: 1, offset: 15922},
			expr: &actionExpr{
				pos: position{line: 554, col: 21, offset: 15942},
				run: (*parser).callonLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 554, col: 21, offset: 15942},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 554, col: 21, offset: 15942},
							val:        "length",
							ignoreCase: true,
							want:       "\"LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 31, offset: 15952},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 34, offset: 15955},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 38, offset: 15959},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 554, col: 41, offset: 15962},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 554, col: 44, offset: 15965},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 554, col: 55, offset: 15976},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 554, col: 58, offset: 15979},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "LTrimExpression",
			pos:  position{line: 558, col: 1, offset: 16065},
			expr: &actionExpr{
				pos: position{line: 558, col: 20, offset: 16084},
				run: (*parser).callonLTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 558, col: 20, offset: 16084},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 558, col: 20, offset: 16084},
							val:        "ltrim",
							ignoreCase: true,
							want:       "\"LTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 29, offset: 16093},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 32, offset: 16096},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 36, offset: 16100},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 558, col: 39, offset: 16103},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 558, col: 42, offset: 16106},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 558, col: 53, offset: 16117},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 558, col: 56, offset: 16120},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplaceExpression",
			pos:  position{line: 562, col: 1, offset: 16205},
			expr: &actionExpr{
				pos: position{line: 562, col: 22, offset: 16226},
				run: (*parser).callonReplaceExpression1,
				expr: &seqExpr{
					pos: position{line: 562, col: 22, offset: 16226},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 562, col: 22, offset: 16226},
							val:        "replace",
							ignoreCase: true,
							want:       "\"REPLACE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 33, offset: 16237},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 36, offset: 16240},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 40, offset: 16244},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 43, offset: 16247},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 47, offset: 16251},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 58, offset: 16262},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 61, offset: 16265},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 65, offset: 16269},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 68, offset: 16272},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 72, offset: 16276},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 83, offset: 16287},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 86, offset: 16290},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 90, offset: 16294},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 562, col: 93, offset: 16297},
							label: "ex3",
							expr: &ruleRefExpr{
								pos:  position{line: 562, col: 97, offset: 16301},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 562, col: 108, offset: 16312},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 562, col: 111, offset: 16315},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReplicateExpression",
			pos:  position{line: 566, col: 1, offset: 16413},
			expr: &actionExpr{
				pos: position{line: 566, col: 24, offset: 16436},
				run: (*parser).callonReplicateExpression1,
				expr: &seqExpr{
					pos: position{line: 566, col: 24, offset: 16436},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 566, col: 24, offset: 16436},
							val:        "replicate",
							ignoreCase: true,
							want:       "\"REPLICATE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 37, offset: 16449},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 566, col: 40, offset: 16452},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 44, offset: 16456},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 566, col: 47, offset: 16459},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 566, col: 51, offset: 16463},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 62, offset: 16474},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 566, col: 65, offset: 16477},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 69, offset: 16481},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 566, col: 72, offset: 16484},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 566, col: 76, offset: 16488},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 566, col: 87, offset: 16499},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 566, col: 90, offset: 16502},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ReverseExpression",
			pos:  position{line: 570, col: 1, offset: 16597},
			expr: &actionExpr{
				pos: position{line: 570, col: 22, offset: 16618},
				run: (*parser).callonReverseExpression1,
				expr: &seqExpr{
					pos: position{line: 570, col: 22, offset: 16618},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 570, col: 22, offset: 16618},
							val:        "reverse",
							ignoreCase: true,
							want:       "\"REVERSE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 33, offset: 16629},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 36, offset: 16632},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 40, offset: 16636},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 570, col: 43, offset: 16639},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 570, col: 46, offset: 16642},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 570, col: 57, offset: 16653},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 570, col: 60, offset: 16656},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RightExpression",
			pos:  position{line: 574, col: 1, offset: 16743},
			expr: &actionExpr{
				pos: position{line: 574, col: 20, offset: 16762},
				run: (*parser).callonRightExpression1,
				expr: &seqExpr{
					pos: position{line: 574, col: 20, offset: 16762},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 574, col: 20, offset: 16762},
							val:        "right",
							ignoreCase: true,
							want:       "\"RIGHT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 29, offset: 16771},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 32, offset: 16774},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 36, offset: 16778},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 574, col: 39, offset: 16781},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 574, col: 42, offset: 16784},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 53, offset: 16795},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 56, offset: 16798},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 60, offset: 16802},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 574, col: 63, offset: 16805},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 574, col: 70, offset: 16812},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 574, col: 81, offset: 16823},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 574, col: 84, offset: 16826},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "RTrimExpression",
			pos:  position{line: 578, col: 1, offset: 16919},
			expr: &actionExpr{
				pos: position{line: 578, col: 20, offset: 16938},
				run: (*parser).callonRTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 578, col: 20, offset: 16938},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 578, col: 20, offset: 16938},
							val:        "rtrim",
							ignoreCase: true,
							want:       "\"RTRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 29, offset: 16947},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 32, offset: 16950},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 36, offset: 16954},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 578, col: 39, offset: 16957},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 578, col: 42, offset: 16960},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 578, col: 53, offset: 16971},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 578, col: 56, offset: 16974},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SubstringExpression",
			pos:  position{line: 582, col: 1, offset: 17059},
			expr: &actionExpr{
				pos: position{line: 582, col: 24, offset: 17082},
				run: (*parser).callonSubstringExpression1,
				expr: &seqExpr{
					pos: position{line: 582, col: 24, offset: 17082},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 582, col: 24, offset: 17082},
							val:        "substring",
							ignoreCase: true,
							want:       "\"SUBSTRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 37, offset: 17095},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 40, offset: 17098},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 44, offset: 17102},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 47, offset: 17105},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 50, offset: 17108},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 61, offset: 17119},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 64, offset: 17122},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 68, offset: 17126},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 71, offset: 17129},
							label: "startPos",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 80, offset: 17138},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 91, offset: 17149},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 94, offset: 17152},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 98, offset: 17156},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 582, col: 101, offset: 17159},
							label: "length",
							expr: &ruleRefExpr{
								pos:  position{line: 582, col: 108, offset: 17166},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 582, col: 119, offset: 17177},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 582, col: 122, offset: 17180},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "TrimExpression",
			pos:  position{line: 586, col: 1, offset: 17287},
			expr: &actionExpr{
				pos: position{line: 586, col: 19, offset: 17305},
				run: (*parser).callonTrimExpression1,
				expr: &seqExpr{
					pos: position{line: 586, col: 19, offset: 17305},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 586, col: 19, offset: 17305},
							val:        "trim",
							ignoreCase: true,
							want:       "\"TRIM\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 27, offset: 17313},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 30, offset: 17316},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 34, offset: 17320},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 586, col: 37, offset: 17323},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 586, col: 40, offset: 17326},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 586, col: 51, offset: 17337},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 586, col: 54, offset: 17340},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunctionExpression",
			pos:  position{line: 590, col: 1, offset: 17424},
			expr: &actionExpr{
				pos: position{line: 590, col: 42, offset: 17465},
				run: (*parser).callonThreeArgumentStringFunctionExpression1,
				expr: &seqExpr{
					pos: position{line: 590, col: 42, offset: 17465},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 590, col: 42, offset: 17465},
							label: "function",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 51, offset: 17474},
								name: "ThreeArgumentStringFunction",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 79, offset: 17502},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 82, offset: 17505},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 86, offset: 17509},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 89, offset: 17512},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 93, offset: 17516},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 104, offset: 17527},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 590, col: 107, offset: 17530},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 111, offset: 17534},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 114, offset: 17537},
							label: "ex2",
							expr: &ruleRefExpr{
								pos:  position{line: 590, col: 118, offset: 17541},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 590, col: 129, offset: 17552},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 590, col: 132, offset: 17555},
							label: "ignoreCase",
							expr: &zeroOrOneExpr{
								pos: position{line: 590, col: 143, offset: 17566},
								expr: &actionExpr{
									pos: position{line: 590, col: 144, offset: 17567},
									run: (*parser).callonThreeArgumentStringFunctionExpression18,
									expr: &seqExpr{
										pos: position{line: 590, col: 144, offset: 17567},
										exprs: []any{
											&litMatcher{
												pos:        position{line: 590, col: 144, offset: 17567},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 590, col: 148, offset: 17571},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 590, col: 151, offset: 17574},
												label: "boolean",
												expr: &ruleRefExpr{
													pos:  position{line: 590, col: 159, offset: 17582},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&litMatcher{
							pos:        position{line: 590, col: 196, offset: 17619},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ThreeArgumentStringFunction",
			pos:  position{line: 608, col: 1, offset: 18141},
			expr: &actionExpr{
				pos: position{line: 608, col: 32, offset: 18172},
				run: (*parser).callonThreeArgumentStringFunction1,
				expr: &choiceExpr{
					pos: position{line: 608, col: 33, offset: 18173},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 608, col: 33, offset: 18173},
							val:        "contains",
							ignoreCase: true,
							want:       "\"CONTAINS\"i",
						},
						&litMatcher{
							pos:        position{line: 608, col: 47, offset: 18187},
							val:        "endswith",
							ignoreCase: true,
							want:       "\"ENDSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 608, col: 61, offset: 18201},
							val:        "startswith",
							ignoreCase: true,
							want:       "\"STARTSWITH\"i",
						},
						&litMatcher{
							pos:        position{line: 608, col: 77, offset: 18217},
							val:        "index_of",
							ignoreCase: true,
							want:       "\"INDEX_OF\"i",
						},
					},
				},
			},
		},
		{
			name: "IsDefined",
			pos:  position{line: 612, col: 1, offset: 18266},
			expr: &actionExpr{
				pos: position{line: 612, col: 14, offset: 18279},
				run: (*parser).callonIsDefined1,
				expr: &seqExpr{
					pos: position{line: 612, col: 14, offset: 18279},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 612, col: 14, offset: 18279},
							val:        "is_defined",
							ignoreCase: true,
							want:       "\"IS_DEFINED\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 28, offset: 18293},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 612, col: 31, offset: 18296},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 35, offset: 18300},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 612, col: 38, offset: 18303},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 612, col: 41, offset: 18306},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 612, col: 52, offset: 18317},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 612, col: 55, offset: 18320},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsArray",
			pos:  position{line: 616, col: 1, offset: 18409},
			expr: &actionExpr{
				pos: position{line: 616, col: 12, offset: 18420},
				run: (*parser).callonIsArray1,
				expr: &seqExpr{
					pos: position{line: 616, col: 12, offset: 18420},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 616, col: 12, offset: 18420},
							val:        "is_array",
							ignoreCase: true,
							want:       "\"IS_ARRAY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 24, offset: 18432},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 616, col: 27, offset: 18435},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 31, offset: 18439},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 616, col: 34, offset: 18442},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 616, col: 37, offset: 18445},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 616, col: 48, offset: 18456},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 616, col: 51, offset: 18459},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsBool",
			pos:  position{line: 620, col: 1, offset: 18546},
			expr: &actionExpr{
				pos: position{line: 620, col: 11, offset: 18556},
				run: (*parser).callonIsBool1,
				expr: &seqExpr{
					pos: position{line: 620, col: 11, offset: 18556},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 620, col: 11, offset: 18556},
							val:        "is_bool",
							ignoreCase: true,
							want:       "\"IS_BOOL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 22, offset: 18567},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 25, offset: 18570},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 29, offset: 18574},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 620, col: 32, offset: 18577},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 620, col: 35, offset: 18580},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 620, col: 46, offset: 18591},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 620, col: 49, offset: 18594},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsFiniteNumber",
			pos:  position{line: 624, col: 1, offset: 18680},
			expr: &actionExpr{
				pos: position{line: 624, col: 19, offset: 18698},
				run: (*parser).callonIsFiniteNumber1,
				expr: &seqExpr{
					pos: position{line: 624, col: 19, offset: 18698},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 624, col: 19, offset: 18698},
							val:        "is_finite_number",
							ignoreCase: true,
							want:       "\"IS_FINITE_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 39, offset: 18718},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 42, offset: 18721},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 46, offset: 18725},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 624, col: 49, offset: 18728},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 624, col: 52, offset: 18731},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 624, col: 63, offset: 18742},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 624, col: 66, offset: 18745},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsInteger",
			pos:  position{line: 628, col: 1, offset: 18839},
			expr: &actionExpr{
				pos: position{line: 628, col: 14, offset: 18852},
				run: (*parser).callonIsInteger1,
				expr: &seqExpr{
					pos: position{line: 628, col: 14, offset: 18852},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 628, col: 14, offset: 18852},
							val:        "is_integer",
							ignoreCase: true,
							want:       "\"IS_INTEGER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 28, offset: 18866},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 31, offset: 18869},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 35, offset: 18873},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 628, col: 38, offset: 18876},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 628, col: 41, offset: 18879},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 628, col: 52, offset: 18890},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 628, col: 55, offset: 18893},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNull",
			pos:  position{line: 632, col: 1, offset: 18982},
			expr: &actionExpr{
				pos: position{line: 632, col: 11, offset: 18992},
				run: (*parser).callonIsNull1,
				expr: &seqExpr{
					pos: position{line: 632, col: 11, offset: 18992},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 632, col: 11, offset: 18992},
							val:        "is_null",
							ignoreCase: true,
							want:       "\"IS_NULL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 22, offset: 19003},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 25, offset: 19006},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 29, offset: 19010},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 632, col: 32, offset: 19013},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 632, col: 35, offset: 19016},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 632, col: 46, offset: 19027},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 632, col: 49, offset: 19030},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsNumber",
			pos:  position{line: 636, col: 1, offset: 19116},
			expr: &actionExpr{
				pos: position{line: 636, col: 13, offset: 19128},
				run: (*parser).callonIsNumber1,
				expr: &seqExpr{
					pos: position{line: 636, col: 13, offset: 19128},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 636, col: 13, offset: 19128},
							val:        "is_number",
							ignoreCase: true,
							want:       "\"IS_NUMBER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 26, offset: 19141},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 29, offset: 19144},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 33, offset: 19148},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 636, col: 36, offset: 19151},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 636, col: 39, offset: 19154},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 636, col: 50, offset: 19165},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 636, col: 53, offset: 19168},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsObject",
			pos:  position{line: 640, col: 1, offset: 19256},
			expr: &actionExpr{
				pos: position{line: 640, col: 13, offset: 19268},
				run: (*parser).callonIsObject1,
				expr: &seqExpr{
					pos: position{line: 640, col: 13, offset: 19268},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 640, col: 13, offset: 19268},
							val:        "is_object",
							ignoreCase: true,
							want:       "\"IS_OBJECT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 26, offset: 19281},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 29, offset: 19284},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 33, offset: 19288},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 640, col: 36, offset: 19291},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 640, col: 39, offset: 19294},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 640, col: 50, offset: 19305},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 640, col: 53, offset: 19308},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsPrimitive",
			pos:  position{line: 644, col: 1, offset: 19396},
			expr: &actionExpr{
				pos: position{line: 644, col: 16, offset: 19411},
				run: (*parser).callonIsPrimitive1,
				expr: &seqExpr{
					pos: position{line: 644, col: 16, offset: 19411},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 644, col: 16, offset: 19411},
							val:        "is_primitive",
							ignoreCase: true,
							want:       "\"IS_PRIMITIVE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 32, offset: 19427},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 35, offset: 19430},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 39, offset: 19434},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 644, col: 42, offset: 19437},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 644, col: 45, offset: 19440},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 644, col: 56, offset: 19451},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 644, col: 59, offset: 19454},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "IsString",
			pos:  position{line: 648, col: 1, offset: 19545},
			expr: &actionExpr{
				pos: position{line: 648, col: 13, offset: 19557},
				run: (*parser).callonIsString1,
				expr: &seqExpr{
					pos: position{line: 648, col: 13, offset: 19557},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 648, col: 13, offset: 19557},
							val:        "is_string",
							ignoreCase: true,
							want:       "\"IS_STRING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 26, offset: 19570},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 29, offset: 19573},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 33, offset: 19577},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 648, col: 36, offset: 19580},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 648, col: 39, offset: 19583},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 648, col: 50, offset: 19594},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 648, col: 53, offset: 19597},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayConcatExpression",
			pos:  position{line: 652, col: 1, offset: 19685},
			expr: &actionExpr{
				pos: position{line: 652, col: 26, offset: 19710},
				run: (*parser).callonArrayConcatExpression1,
				expr: &seqExpr{
					pos: position{line: 652, col: 26, offset: 19710},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 652, col: 26, offset: 19710},
							val:        "array_concat",
							ignoreCase: true,
							want:       "\"ARRAY_CONCAT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 42, offset: 19726},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 45, offset: 19729},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 49, offset: 19733},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 652, col: 52, offset: 19736},
							label: "arrays",
							expr: &ruleRefExpr{
								pos:  position{line: 652, col: 59, offset: 19743},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 652, col: 70, offset: 19754},
							label: "others",
							expr: &oneOrMoreExpr{
								pos: position{line: 652, col: 77, offset: 19761},
								expr: &actionExpr{
									pos: position{line: 652, col: 78, offset: 19762},
									run: (*parser).callonArrayConcatExpression11,
									expr: &seqExpr{
										pos: position{line: 652, col: 78, offset: 19762},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 652, col: 78, offset: 19762},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 652, col: 81, offset: 19765},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 652, col: 85, offset: 19769},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 652, col: 88, offset: 19772},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 652, col: 91, offset: 19775},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 652, col: 123, offset: 19807},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 652, col: 126, offset: 19810},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsExpression",
			pos:  position{line: 656, col: 1, offset: 19940},
			expr: &actionExpr{
				pos: position{line: 656, col: 28, offset: 19967},
				run: (*parser).callonArrayContainsExpression1,
				expr: &seqExpr{
					pos: position{line: 656, col: 28, offset: 19967},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 656, col: 28, offset: 19967},
							val:        "array_contains",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 46, offset: 19985},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 49, offset: 19988},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 53, offset: 19992},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 656, col: 56, offset: 19995},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 656, col: 62, offset: 20001},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 73, offset: 20012},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 76, offset: 20015},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 80, offset: 20019},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 656, col: 83, offset: 20022},
							label: "item",
							expr: &ruleRefExpr{
								pos:  position{line: 656, col: 88, offset: 20027},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 656, col: 99, offset: 20038},
							label: "partialMatch",
							expr: &zeroOrOneExpr{
								pos: position{line: 656, col: 112, offset: 20051},
								expr: &actionExpr{
									pos: position{line: 656, col: 113, offset: 20052},
									run: (*parser).callonArrayContainsExpression16,
									expr: &seqExpr{
										pos: position{line: 656, col: 113, offset: 20052},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 656, col: 113, offset: 20052},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 656, col: 116, offset: 20055},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 656, col: 120, offset: 20059},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 656, col: 123, offset: 20062},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 656, col: 126, offset: 20065},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 656, col: 158, offset: 20097},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 656, col: 161, offset: 20100},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAnyExpression",
			pos:  position{line: 660, col: 1, offset: 20216},
			expr: &actionExpr{
				pos: position{line: 660, col: 31, offset: 20246},
				run: (*parser).callonArrayContainsAnyExpression1,
				expr: &seqExpr{
					pos: position{line: 660, col: 31, offset: 20246},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 660, col: 31, offset: 20246},
							val:        "array_contains_any",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ANY\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 53, offset: 20268},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 56, offset: 20271},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 60, offset: 20275},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 660, col: 63, offset: 20278},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 660, col: 69, offset: 20284},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 660, col: 80, offset: 20295},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 660, col: 86, offset: 20301},
								expr: &actionExpr{
									pos: position{line: 660, col: 87, offset: 20302},
									run: (*parser).callonArrayContainsAnyExpression11,
									expr: &seqExpr{
										pos: position{line: 660, col: 87, offset: 20302},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 660, col: 87, offset: 20302},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 660, col: 90, offset: 20305},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 660, col: 94, offset: 20309},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 660, col: 97, offset: 20312},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 660, col: 100, offset: 20315},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 660, col: 132, offset: 20347},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 660, col: 135, offset: 20350},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayContainsAllExpression",
			pos:  position{line: 664, col: 1, offset: 20483},
			expr: &actionExpr{
				pos: position{line: 664, col: 31, offset: 20513},
				run: (*parser).callonArrayContainsAllExpression1,
				expr: &seqExpr{
					pos: position{line: 664, col: 31, offset: 20513},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 664, col: 31, offset: 20513},
							val:        "array_contains_all",
							ignoreCase: true,
							want:       "\"ARRAY_CONTAINS_ALL\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 53, offset: 20535},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 664, col: 56, offset: 20538},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 60, offset: 20542},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 664, col: 63, offset: 20545},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 664, col: 69, offset: 20551},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 664, col: 80, offset: 20562},
							label: "items",
							expr: &oneOrMoreExpr{
								pos: position{line: 664, col: 86, offset: 20568},
								expr: &actionExpr{
									pos: position{line: 664, col: 87, offset: 20569},
									run: (*parser).callonArrayContainsAllExpression11,
									expr: &seqExpr{
										pos: position{line: 664, col: 87, offset: 20569},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 664, col: 87, offset: 20569},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 664, col: 90, offset: 20572},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 664, col: 94, offset: 20576},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 664, col: 97, offset: 20579},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 664, col: 100, offset: 20582},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 664, col: 132, offset: 20614},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 664, col: 135, offset: 20617},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArrayLengthExpression",
			pos:  position{line: 668, col: 1, offset: 20750},
			expr: &actionExpr{
				pos: position{line: 668, col: 26, offset: 20775},
				run: (*parser).callonArrayLengthExpression1,
				expr: &seqExpr{
					pos: position{line: 668, col: 26, offset: 20775},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 668, col: 26, offset: 20775},
							val:        "array_length",
							ignoreCase: true,
							want:       "\"ARRAY_LENGTH\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 42, offset: 20791},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 45, offset: 20794},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 49, offset: 20798},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 668, col: 52, offset: 20801},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 668, col: 58, offset: 20807},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 668, col: 69, offset: 20818},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 668, col: 72, offset: 20821},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "ArraySliceExpression",
			pos:  position{line: 672, col: 1, offset: 20915},
			expr: &actionExpr{
				pos: position{line: 672, col: 25, offset: 20939},
				run: (*parser).callonArraySliceExpression1,
				expr: &seqExpr{
					pos: position{line: 672, col: 25, offset: 20939},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 672, col: 25, offset: 20939},
							val:        "array_slice",
							ignoreCase: true,
							want:       "\"ARRAY_SLICE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 40, offset: 20954},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 43, offset: 20957},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 47, offset: 20961},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 672, col: 50, offset: 20964},
							label: "array",
							expr: &ruleRefExpr{
								pos:  position{line: 672, col: 56, offset: 20970},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 67, offset: 20981},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 70, offset: 20984},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 74, offset: 20988},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 672, col: 77, offset: 20991},
							label: "start",
							expr: &ruleRefExpr{
								pos:  position{line: 672, col: 83, offset: 20997},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 672, col: 94, offset: 21008},
							label: "length",
							expr: &zeroOrOneExpr{
								pos: position{line: 672, col: 101, offset: 21015},
								expr: &actionExpr{
									pos: position{line: 672, col: 102, offset: 21016},
									run: (*parser).callonArraySliceExpression16,
									expr: &seqExpr{
										pos: position{line: 672, col: 102, offset: 21016},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 672, col: 102, offset: 21016},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 672, col: 105, offset: 21019},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 672, col: 109, offset: 21023},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 672, col: 112, offset: 21026},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 672, col: 115, offset: 21029},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 672, col: 147, offset: 21061},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 672, col: 150, offset: 21064},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetIntersectExpression",
			pos:  position{line: 676, col: 1, offset: 21172},
			expr: &actionExpr{
				pos: position{line: 676, col: 27, offset: 21198},
				run: (*parser).callonSetIntersectExpression1,
				expr: &seqExpr{
					pos: position{line: 676, col: 27, offset: 21198},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 676, col: 27, offset: 21198},
							val:        "setintersect",
							ignoreCase: true,
							want:       "\"SetIntersect\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 43, offset: 21214},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 46, offset: 21217},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 50, offset: 21221},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 676, col: 53, offset: 21224},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 676, col: 58, offset: 21229},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 69, offset: 21240},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 72, offset: 21243},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 76, offset: 21247},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 676, col: 79, offset: 21250},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 676, col: 84, offset: 21255},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 676, col: 95, offset: 21266},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 676, col: 98, offset: 21269},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SetUnionExpression",
			pos:  position{line: 680, col: 1, offset: 21369},
			expr: &actionExpr{
				pos: position{line: 680, col: 23, offset: 21391},
				run: (*parser).callonSetUnionExpression1,
				expr: &seqExpr{
					pos: position{line: 680, col: 23, offset: 21391},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 680, col: 23, offset: 21391},
							val:        "setunion",
							ignoreCase: true,
							want:       "\"SetUnion\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 35, offset: 21403},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 38, offset: 21406},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 42, offset: 21410},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 680, col: 45, offset: 21413},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 680, col: 50, offset: 21418},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 61, offset: 21429},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 64, offset: 21432},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 68, offset: 21436},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 680, col: 71, offset: 21439},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 680, col: 76, offset: 21444},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 680, col: 87, offset: 21455},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 680, col: 90, offset: 21458},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAbsExpression",
			pos:  position{line: 684, col: 1, offset: 21554},
			expr: &actionExpr{
				pos: position{line: 684, col: 22, offset: 21575},
				run: (*parser).callonMathAbsExpression1,
				expr: &seqExpr{
					pos: position{line: 684, col: 22, offset: 21575},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 684, col: 22, offset: 21575},
							val:        "abs",
							ignoreCase: true,
							want:       "\"ABS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 29, offset: 21582},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 32, offset: 21585},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 36, offset: 21589},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 684, col: 39, offset: 21592},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 684, col: 42, offset: 21595},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 684, col: 53, offset: 21606},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 684, col: 56, offset: 21609},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAcosExpression",
			pos:  position{line: 685, col: 1, offset: 21691},
			expr: &actionExpr{
				pos: position{line: 685, col: 23, offset: 21713},
				run: (*parser).callonMathAcosExpression1,
				expr: &seqExpr{
					pos: position{line: 685, col: 23, offset: 21713},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 685, col: 23, offset: 21713},
							val:        "acos",
							ignoreCase: true,
							want:       "\"ACOS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 685, col: 31, offset: 21721},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 685, col: 34, offset: 21724},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 685, col: 38, offset: 21728},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 685, col: 41, offset: 21731},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 685, col: 44, offset: 21734},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 685, col: 55, offset: 21745},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 685, col: 58, offset: 21748},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAsinExpression",
			pos:  position{line: 686, col: 1, offset: 21831},
			expr: &actionExpr{
				pos: position{line: 686, col: 23, offset: 21853},
				run: (*parser).callonMathAsinExpression1,
				expr: &seqExpr{
					pos: position{line: 686, col: 23, offset: 21853},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 686, col: 23, offset: 21853},
							val:        "asin",
							ignoreCase: true,
							want:       "\"ASIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 686, col: 31, offset: 21861},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 686, col: 34, offset: 21864},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 686, col: 38, offset: 21868},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 686, col: 41, offset: 21871},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 686, col: 44, offset: 21874},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 686, col: 55, offset: 21885},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 686, col: 58, offset: 21888},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtanExpression",
			pos:  position{line: 687, col: 1, offset: 21971},
			expr: &actionExpr{
				pos: position{line: 687, col: 23, offset: 21993},
				run: (*parser).callonMathAtanExpression1,
				expr: &seqExpr{
					pos: position{line: 687, col: 23, offset: 21993},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 687, col: 23, offset: 21993},
							val:        "atan",
							ignoreCase: true,
							want:       "\"ATAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 31, offset: 22001},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 34, offset: 22004},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 38, offset: 22008},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 687, col: 41, offset: 22011},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 687, col: 44, offset: 22014},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 687, col: 55, offset: 22025},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 687, col: 58, offset: 22028},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCeilingExpression",
			pos:  position{line: 688, col: 1, offset: 22111},
			expr: &actionExpr{
				pos: position{line: 688, col: 26, offset: 22136},
				run: (*parser).callonMathCeilingExpression1,
				expr: &seqExpr{
					pos: position{line: 688, col: 26, offset: 22136},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 688, col: 26, offset: 22136},
							val:        "ceiling",
							ignoreCase: true,
							want:       "\"CEILING\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 37, offset: 22147},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 688, col: 40, offset: 22150},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 44, offset: 22154},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 688, col: 47, offset: 22157},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 688, col: 50, offset: 22160},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 688, col: 61, offset: 22171},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 688, col: 64, offset: 22174},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCosExpression",
			pos:  position{line: 689, col: 1, offset: 22260},
			expr: &actionExpr{
				pos: position{line: 689, col: 22, offset: 22281},
				run: (*parser).callonMathCosExpression1,
				expr: &seqExpr{
					pos: position{line: 689, col: 22, offset: 22281},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 689, col: 22, offset: 22281},
							val:        "cos",
							ignoreCase: true,
							want:       "\"COS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 689, col: 29, offset: 22288},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 689, col: 32, offset: 22291},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 689, col: 36, offset: 22295},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 689, col: 39, offset: 22298},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 689, col: 42, offset: 22301},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 689, col: 53, offset: 22312},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 689, col: 56, offset: 22315},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathCotExpression",
			pos:  position{line: 690, col: 1, offset: 22397},
			expr: &actionExpr{
				pos: position{line: 690, col: 22, offset: 22418},
				run: (*parser).callonMathCotExpression1,
				expr: &seqExpr{
					pos: position{line: 690, col: 22, offset: 22418},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 690, col: 22, offset: 22418},
							val:        "cot",
							ignoreCase: true,
							want:       "\"COT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 690, col: 29, offset: 22425},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 690, col: 32, offset: 22428},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 690, col: 36, offset: 22432},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 690, col: 39, offset: 22435},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 690, col: 42, offset: 22438},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 690, col: 53, offset: 22449},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 690, col: 56, offset: 22452},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathDegreesExpression",
			pos:  position{line: 691, col: 1, offset: 22534},
			expr: &actionExpr{
				pos: position{line: 691, col: 26, offset: 22559},
				run: (*parser).callonMathDegreesExpression1,
				expr: &seqExpr{
					pos: position{line: 691, col: 26, offset: 22559},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 691, col: 26, offset: 22559},
							val:        "degrees",
							ignoreCase: true,
							want:       "\"DEGREES\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 37, offset: 22570},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 40, offset: 22573},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 44, offset: 22577},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 691, col: 47, offset: 22580},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 691, col: 50, offset: 22583},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 691, col: 61, offset: 22594},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 691, col: 64, offset: 22597},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathExpExpression",
			pos:  position{line: 692, col: 1, offset: 22683},
			expr: &actionExpr{
				pos: position{line: 692, col: 22, offset: 22704},
				run: (*parser).callonMathExpExpression1,
				expr: &seqExpr{
					pos: position{line: 692, col: 22, offset: 22704},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 692, col: 22, offset: 22704},
							val:        "exp",
							ignoreCase: true,
							want:       "\"EXP\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 29, offset: 22711},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 32, offset: 22714},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 36, offset: 22718},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 692, col: 39, offset: 22721},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 692, col: 42, offset: 22724},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 692, col: 53, offset: 22735},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 692, col: 56, offset: 22738},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathFloorExpression",
			pos:  position{line: 693, col: 1, offset: 22820},
			expr: &actionExpr{
				pos: position{line: 693, col: 24, offset: 22843},
				run: (*parser).callonMathFloorExpression1,
				expr: &seqExpr{
					pos: position{line: 693, col: 24, offset: 22843},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 693, col: 24, offset: 22843},
							val:        "floor",
							ignoreCase: true,
							want:       "\"FLOOR\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 693, col: 33, offset: 22852},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 693, col: 36, offset: 22855},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 693, col: 40, offset: 22859},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 693, col: 43, offset: 22862},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 693, col: 46, offset: 22865},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 693, col: 57, offset: 22876},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 693, col: 60, offset: 22879},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitNotExpression",
			pos:  position{line: 694, col: 1, offset: 22963},
			expr: &actionExpr{
				pos: position{line: 694, col: 28, offset: 22990},
				run: (*parser).callonMathIntBitNotExpression1,
				expr: &seqExpr{
					pos: position{line: 694, col: 28, offset: 22990},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 694, col: 28, offset: 22990},
							val:        "intbitnot",
							ignoreCase: true,
							want:       "\"IntBitNot\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 694, col: 41, offset: 23003},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 694, col: 44, offset: 23006},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 694, col: 48, offset: 23010},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 694, col: 51, offset: 23013},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 694, col: 54, offset: 23016},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 694, col: 65, offset: 23027},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 694, col: 68, offset: 23030},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLog10Expression",
			pos:  position{line: 695, col: 1, offset: 23118},
			expr: &actionExpr{
				pos: position{line: 695, col: 24, offset: 23141},
				run: (*parser).callonMathLog10Expression1,
				expr: &seqExpr{
					pos: position{line: 695, col: 24, offset: 23141},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 695, col: 24, offset: 23141},
							val:        "log10",
							ignoreCase: true,
							want:       "\"LOG10\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 33, offset: 23150},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 695, col: 36, offset: 23153},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 40, offset: 23157},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 695, col: 43, offset: 23160},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 695, col: 46, offset: 23163},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 695, col: 57, offset: 23174},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 695, col: 60, offset: 23177},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRadiansExpression",
			pos:  position{line: 696, col: 1, offset: 23261},
			expr: &actionExpr{
				pos: position{line: 696, col: 26, offset: 23286},
				run: (*parser).callonMathRadiansExpression1,
				expr: &seqExpr{
					pos: position{line: 696, col: 26, offset: 23286},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 696, col: 26, offset: 23286},
							val:        "radians",
							ignoreCase: true,
							want:       "\"RADIANS\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 37, offset: 23297},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 696, col: 40, offset: 23300},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 44, offset: 23304},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 696, col: 47, offset: 23307},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 696, col: 50, offset: 23310},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 696, col: 61, offset: 23321},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 696, col: 64, offset: 23324},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRoundExpression",
			pos:  position{line: 697, col: 1, offset: 23410},
			expr: &actionExpr{
				pos: position{line: 697, col: 24, offset: 23433},
				run: (*parser).callonMathRoundExpression1,
				expr: &seqExpr{
					pos: position{line: 697, col: 24, offset: 23433},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 697, col: 24, offset: 23433},
							val:        "round",
							ignoreCase: true,
							want:       "\"ROUND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 33, offset: 23442},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 697, col: 36, offset: 23445},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 40, offset: 23449},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 697, col: 43, offset: 23452},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 697, col: 46, offset: 23455},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 697, col: 57, offset: 23466},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 697, col: 60, offset: 23469},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSignExpression",
			pos:  position{line: 698, col: 1, offset: 23553},
			expr: &actionExpr{
				pos: position{line: 698, col: 23, offset: 23575},
				run: (*parser).callonMathSignExpression1,
				expr: &seqExpr{
					pos: position{line: 698, col: 23, offset: 23575},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 698, col: 23, offset: 23575},
							val:        "sign",
							ignoreCase: true,
							want:       "\"SIGN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 31, offset: 23583},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 698, col: 34, offset: 23586},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 38, offset: 23590},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 698, col: 41, offset: 23593},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 698, col: 44, offset: 23596},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 698, col: 55, offset: 23607},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 698, col: 58, offset: 23610},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSinExpression",
			pos:  position{line: 699, col: 1, offset: 23693},
			expr: &actionExpr{
				pos: position{line: 699, col: 22, offset: 23714},
				run: (*parser).callonMathSinExpression1,
				expr: &seqExpr{
					pos: position{line: 699, col: 22, offset: 23714},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 699, col: 22, offset: 23714},
							val:        "sin",
							ignoreCase: true,
							want:       "\"SIN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 29, offset: 23721},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 32, offset: 23724},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 36, offset: 23728},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 699, col: 39, offset: 23731},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 699, col: 42, offset: 23734},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 699, col: 53, offset: 23745},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 699, col: 56, offset: 23748},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSqrtExpression",
			pos:  position{line: 700, col: 1, offset: 23830},
			expr: &actionExpr{
				pos: position{line: 700, col: 23, offset: 23852},
				run: (*parser).callonMathSqrtExpression1,
				expr: &seqExpr{
					pos: position{line: 700, col: 23, offset: 23852},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 700, col: 23, offset: 23852},
							val:        "sqrt",
							ignoreCase: true,
							want:       "\"SQRT\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 31, offset: 23860},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 700, col: 34, offset: 23863},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 38, offset: 23867},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 700, col: 41, offset: 23870},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 700, col: 44, offset: 23873},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 700, col: 55, offset: 23884},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 700, col: 58, offset: 23887},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathSquareExpression",
			pos:  position{line: 701, col: 1, offset: 23970},
			expr: &actionExpr{
				pos: position{line: 701, col: 25, offset: 23994},
				run: (*parser).callonMathSquareExpression1,
				expr: &seqExpr{
					pos: position{line: 701, col: 25, offset: 23994},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 701, col: 25, offset: 23994},
							val:        "square",
							ignoreCase: true,
							want:       "\"SQUARE\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 35, offset: 24004},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 701, col: 38, offset: 24007},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 42, offset: 24011},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 701, col: 45, offset: 24014},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 701, col: 48, offset: 24017},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 701, col: 59, offset: 24028},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 701, col: 62, offset: 24031},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTanExpression",
			pos:  position{line: 702, col: 1, offset: 24116},
			expr: &actionExpr{
				pos: position{line: 702, col: 22, offset: 24137},
				run: (*parser).callonMathTanExpression1,
				expr: &seqExpr{
					pos: position{line: 702, col: 22, offset: 24137},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 702, col: 22, offset: 24137},
							val:        "tan",
							ignoreCase: true,
							want:       "\"TAN\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 29, offset: 24144},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 702, col: 32, offset: 24147},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 36, offset: 24151},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 702, col: 39, offset: 24154},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 702, col: 42, offset: 24157},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 702, col: 53, offset: 24168},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 702, col: 56, offset: 24171},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathTruncExpression",
			pos:  position{line: 703, col: 1, offset: 24253},
			expr: &actionExpr{
				pos: position{line: 703, col: 24, offset: 24276},
				run: (*parser).callonMathTruncExpression1,
				expr: &seqExpr{
					pos: position{line: 703, col: 24, offset: 24276},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 703, col: 24, offset: 24276},
							val:        "trunc",
							ignoreCase: true,
							want:       "\"TRUNC\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 33, offset: 24285},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 36, offset: 24288},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 40, offset: 24292},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 703, col: 43, offset: 24295},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 703, col: 46, offset: 24298},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 703, col: 57, offset: 24309},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 703, col: 60, offset: 24312},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathAtn2Expression",
			pos:  position{line: 705, col: 1, offset: 24397},
			expr: &actionExpr{
				pos: position{line: 705, col: 23, offset: 24419},
				run: (*parser).callonMathAtn2Expression1,
				expr: &seqExpr{
					pos: position{line: 705, col: 23, offset: 24419},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 705, col: 23, offset: 24419},
							val:        "atn2",
							ignoreCase: true,
							want:       "\"ATN2\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 31, offset: 24427},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 705, col: 34, offset: 24430},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 38, offset: 24434},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 705, col: 41, offset: 24437},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 705, col: 46, offset: 24442},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 57, offset: 24453},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 705, col: 60, offset: 24456},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 64, offset: 24460},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 705, col: 67, offset: 24463},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 705, col: 72, offset: 24468},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 705, col: 83, offset: 24479},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 705, col: 86, offset: 24482},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntAddExpression",
			pos:  position{line: 706, col: 1, offset: 24573},
			expr: &actionExpr{
				pos: position{line: 706, col: 25, offset: 24597},
				run: (*parser).callonMathIntAddExpression1,
				expr: &seqExpr{
					pos: position{line: 706, col: 25, offset: 24597},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 706, col: 25, offset: 24597},
							val:        "intadd",
							ignoreCase: true,
							want:       "\"IntAdd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 35, offset: 24607},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 706, col: 38, offset: 24610},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 42, offset: 24614},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 706, col: 45, offset: 24617},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 706, col: 50, offset: 24622},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 61, offset: 24633},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 706, col: 64, offset: 24636},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 68, offset: 24640},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 706, col: 71, offset: 24643},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 706, col: 76, offset: 24648},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 706, col: 87, offset: 24659},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 706, col: 90, offset: 24662},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitAndExpression",
			pos:  position{line: 707, col: 1, offset: 24755},
			expr: &actionExpr{
				pos: position{line: 707, col: 28, offset: 24782},
				run: (*parser).callonMathIntBitAndExpression1,
				expr: &seqExpr{
					pos: position{line: 707, col: 28, offset: 24782},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 707, col: 28, offset: 24782},
							val:        "intbitand",
							ignoreCase: true,
							want:       "\"IntBitAnd\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 41, offset: 24795},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 44, offset: 24798},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 48, offset: 24802},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 51, offset: 24805},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 56, offset: 24810},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 67, offset: 24821},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 70, offset: 24824},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 74, offset: 24828},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 707, col: 77, offset: 24831},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 707, col: 82, offset: 24836},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 707, col: 93, offset: 24847},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 707, col: 96, offset: 24850},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitLeftShiftExpression",
			pos:  position{line: 708, col: 1, offset: 24946},
			expr: &actionExpr{
				pos: position{line: 708, col: 34, offset: 24979},
				run: (*parser).callonMathIntBitLeftShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 708, col: 34, offset: 24979},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 708, col: 34, offset: 24979},
							val:        "intbitleftshift",
							ignoreCase: true,
							want:       "\"IntBitLeftShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 53, offset: 24998},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 708, col: 56, offset: 25001},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 60, offset: 25005},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 708, col: 63, offset: 25008},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 708, col: 68, offset: 25013},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 79, offset: 25024},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 708, col: 82, offset: 25027},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 86, offset: 25031},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 708, col: 89, offset: 25034},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 708, col: 94, offset: 25039},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 708, col: 105, offset: 25050},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 708, col: 108, offset: 25053},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitOrExpression",
			pos:  position{line: 709, col: 1, offset: 25155},
			expr: &actionExpr{
				pos: position{line: 709, col: 27, offset: 25181},
				run: (*parser).callonMathIntBitOrExpression1,
				expr: &seqExpr{
					pos: position{line: 709, col: 27, offset: 25181},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 709, col: 27, offset: 25181},
							val:        "intbitor",
							ignoreCase: true,
							want:       "\"IntBitOr\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 39, offset: 25193},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 709, col: 42, offset: 25196},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 46, offset: 25200},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 709, col: 49, offset: 25203},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 709, col: 54, offset: 25208},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 65, offset: 25219},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 709, col: 68, offset: 25222},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 72, offset: 25226},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 709, col: 75, offset: 25229},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 709, col: 80, offset: 25234},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 709, col: 91, offset: 25245},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 709, col: 94, offset: 25248},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitRightShiftExpression",
			pos:  position{line: 710, col: 1, offset: 25343},
			expr: &actionExpr{
				pos: position{line: 710, col: 35, offset: 25377},
				run: (*parser).callonMathIntBitRightShiftExpression1,
				expr: &seqExpr{
					pos: position{line: 710, col: 35, offset: 25377},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 710, col: 35, offset: 25377},
							val:        "intbitrightshift",
							ignoreCase: true,
							want:       "\"IntBitRightShift\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 55, offset: 25397},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 710, col: 58, offset: 25400},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 62, offset: 25404},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 710, col: 65, offset: 25407},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 710, col: 70, offset: 25412},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 81, offset: 25423},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 710, col: 84, offset: 25426},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 88, offset: 25430},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 710, col: 91, offset: 25433},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 710, col: 96, offset: 25438},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 710, col: 107, offset: 25449},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 710, col: 110, offset: 25452},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntBitXorExpression",
			pos:  position{line: 711, col: 1, offset: 25555},
			expr: &actionExpr{
				pos: position{line: 711, col: 28, offset: 25582},
				run: (*parser).callonMathIntBitXorExpression1,
				expr: &seqExpr{
					pos: position{line: 711, col: 28, offset: 25582},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 711, col: 28, offset: 25582},
							val:        "intbitxor",
							ignoreCase: true,
							want:       "\"IntBitXor\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 41, offset: 25595},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 44, offset: 25598},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 48, offset: 25602},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 711, col: 51, offset: 25605},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 711, col: 56, offset: 25610},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 67, offset: 25621},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 70, offset: 25624},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 74, offset: 25628},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 711, col: 77, offset: 25631},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 711, col: 82, offset: 25636},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 711, col: 93, offset: 25647},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 711, col: 96, offset: 25650},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntDivExpression",
			pos:  position{line: 712, col: 1, offset: 25746},
			expr: &actionExpr{
				pos: position{line: 712, col: 25, offset: 25770},
				run: (*parser).callonMathIntDivExpression1,
				expr: &seqExpr{
					pos: position{line: 712, col: 25, offset: 25770},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 712, col: 25, offset: 25770},
							val:        "intdiv",
							ignoreCase: true,
							want:       "\"IntDiv\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 35, offset: 25780},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 712, col: 38, offset: 25783},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 42, offset: 25787},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 712, col: 45, offset: 25790},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 712, col: 50, offset: 25795},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 61, offset: 25806},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 712, col: 64, offset: 25809},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 68, offset: 25813},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 712, col: 71, offset: 25816},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 712, col: 76, offset: 25821},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 712, col: 87, offset: 25832},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 712, col: 90, offset: 25835},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntModExpression",
			pos:  position{line: 713, col: 1, offset: 25928},
			expr: &actionExpr{
				pos: position{line: 713, col: 25, offset: 25952},
				run: (*parser).callonMathIntModExpression1,
				expr: &seqExpr{
					pos: position{line: 713, col: 25, offset: 25952},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 713, col: 25, offset: 25952},
							val:        "intmod",
							ignoreCase: true,
							want:       "\"IntMod\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 35, offset: 25962},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 713, col: 38, offset: 25965},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 42, offset: 25969},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 713, col: 45, offset: 25972},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 713, col: 50, offset: 25977},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 61, offset: 25988},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 713, col: 64, offset: 25991},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 68, offset: 25995},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 713, col: 71, offset: 25998},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 713, col: 76, offset: 26003},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 713, col: 87, offset: 26014},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 713, col: 90, offset: 26017},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntMulExpression",
			pos:  position{line: 714, col: 1, offset: 26110},
			expr: &actionExpr{
				pos: position{line: 714, col: 25, offset: 26134},
				run: (*parser).callonMathIntMulExpression1,
				expr: &seqExpr{
					pos: position{line: 714, col: 25, offset: 26134},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 714, col: 25, offset: 26134},
							val:        "intmul",
							ignoreCase: true,
							want:       "\"IntMul\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 35, offset: 26144},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 714, col: 38, offset: 26147},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 42, offset: 26151},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 714, col: 45, offset: 26154},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 714, col: 50, offset: 26159},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 61, offset: 26170},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 714, col: 64, offset: 26173},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 68, offset: 26177},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 714, col: 71, offset: 26180},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 714, col: 76, offset: 26185},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 714, col: 87, offset: 26196},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 714, col: 90, offset: 26199},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathIntSubExpression",
			pos:  position{line: 715, col: 1, offset: 26292},
			expr: &actionExpr{
				pos: position{line: 715, col: 25, offset: 26316},
				run: (*parser).callonMathIntSubExpression1,
				expr: &seqExpr{
					pos: position{line: 715, col: 25, offset: 26316},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 715, col: 25, offset: 26316},
							val:        "intsub",
							ignoreCase: true,
							want:       "\"IntSub\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 35, offset: 26326},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 38, offset: 26329},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 42, offset: 26333},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 715, col: 45, offset: 26336},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 715, col: 50, offset: 26341},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 61, offset: 26352},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 64, offset: 26355},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 68, offset: 26359},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 715, col: 71, offset: 26362},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 715, col: 76, offset: 26367},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 715, col: 87, offset: 26378},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 715, col: 90, offset: 26381},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPowerExpression",
			pos:  position{line: 716, col: 1, offset: 26474},
			expr: &actionExpr{
				pos: position{line: 716, col: 24, offset: 26497},
				run: (*parser).callonMathPowerExpression1,
				expr: &seqExpr{
					pos: position{line: 716, col: 24, offset: 26497},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 716, col: 24, offset: 26497},
							val:        "power",
							ignoreCase: true,
							want:       "\"POWER\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 716, col: 33, offset: 26506},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 716, col: 36, offset: 26509},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 716, col: 40, offset: 26513},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 716, col: 43, offset: 26516},
							label: "set1",
							expr: &ruleRefExpr{
								pos:  position{line: 716, col: 48, offset: 26521},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 716, col: 59, offset: 26532},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 716, col: 62, offset: 26535},
							val:        ",",
							ignoreCase: false,
							want:       "\",\"",
						},
						&ruleRefExpr{
							pos:  position{line: 716, col: 66, offset: 26539},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 716, col: 69, offset: 26542},
							label: "set2",
							expr: &ruleRefExpr{
								pos:  position{line: 716, col: 74, offset: 26547},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 716, col: 85, offset: 26558},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 716, col: 88, offset: 26561},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathLogExpression",
			pos:  position{line: 718, col: 1, offset: 26654},
			expr: &actionExpr{
				pos: position{line: 718, col: 22, offset: 26675},
				run: (*parser).callonMathLogExpression1,
				expr: &seqExpr{
					pos: position{line: 718, col: 22, offset: 26675},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 718, col: 22, offset: 26675},
							val:        "log",
							ignoreCase: true,
							want:       "\"LOG\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 29, offset: 26682},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 718, col: 32, offset: 26685},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 36, offset: 26689},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 718, col: 39, offset: 26692},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 718, col: 43, offset: 26696},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 718, col: 54, offset: 26707},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 718, col: 61, offset: 26714},
								expr: &actionExpr{
									pos: position{line: 718, col: 62, offset: 26715},
									run: (*parser).callonMathLogExpression11,
									expr: &seqExpr{
										pos: position{line: 718, col: 62, offset: 26715},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 718, col: 62, offset: 26715},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 718, col: 65, offset: 26718},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 718, col: 69, offset: 26722},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 718, col: 72, offset: 26725},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 718, col: 75, offset: 26728},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 718, col: 107, offset: 26760},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 718, col: 110, offset: 26763},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathNumberBinExpression",
			pos:  position{line: 721, col: 1, offset: 26885},
			expr: &actionExpr{
				pos: position{line: 721, col: 28, offset: 26912},
				run: (*parser).callonMathNumberBinExpression1,
				expr: &seqExpr{
					pos: position{line: 721, col: 28, offset: 26912},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 721, col: 28, offset: 26912},
							val:        "numberbin",
							ignoreCase: true,
							want:       "\"NumberBin\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 41, offset: 26925},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 721, col: 44, offset: 26928},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 48, offset: 26932},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 721, col: 51, offset: 26935},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 721, col: 55, offset: 26939},
								name: "SelectItem",
							},
						},
						&labeledExpr{
							pos:   position{line: 721, col: 66, offset: 26950},
							label: "others",
							expr: &zeroOrMoreExpr{
								pos: position{line: 721, col: 73, offset: 26957},
								expr: &actionExpr{
									pos: position{line: 721, col: 74, offset: 26958},
									run: (*parser).callonMathNumberBinExpression11,
									expr: &seqExpr{
										pos: position{line: 721, col: 74, offset: 26958},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 721, col: 74, offset: 26958},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 721, col: 77, offset: 26961},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 721, col: 81, offset: 26965},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 721, col: 84, offset: 26968},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 721, col: 87, offset: 26971},
													name: "SelectItem",
												},
											},
										},
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 721, col: 119, offset: 27003},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 721, col: 122, offset: 27006},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathPiExpression",
			pos:  position{line: 724, col: 1, offset: 27134},
			expr: &actionExpr{
				pos: position{line: 724, col: 21, offset: 27154},
				run: (*parser).callonMathPiExpression1,
				expr: &seqExpr{
					pos: position{line: 724, col: 21, offset: 27154},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 724, col: 21, offset: 27154},
							val:        "pi",
							ignoreCase: true,
							want:       "\"PI\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 27, offset: 27160},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 30, offset: 27163},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 724, col: 34, offset: 27167},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 724, col: 37, offset: 27170},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MathRandExpression",
			pos:  position{line: 725, col: 1, offset: 27249},
			expr: &actionExpr{
				pos: position{line: 725, col: 23, offset: 27271},
				run: (*parser).callonMathRandExpression1,
				expr: &seqExpr{
					pos: position{line: 725, col: 23, offset: 27271},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 725, col: 23, offset: 27271},
							val:        "rand",
							ignoreCase: true,
							want:       "\"RAND\"i",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 31, offset: 27279},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 34, offset: 27282},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 725, col: 38, offset: 27286},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 725, col: 41, offset: 27289},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "InFunction",
			pos:  position{line: 727, col: 1, offset: 27371},
			expr: &choiceExpr{
				pos: position{line: 727, col: 15, offset: 27385},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 727, col: 15, offset: 27385},
						run: (*parser).callonInFunction2,
						expr: &seqExpr{
							pos: position{line: 727, col: 15, offset: 27385},
							exprs: []any{
								&labeledExpr{
									pos:   position{line: 727, col: 15, offset: 27385},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 727, col: 19, offset: 27389},
										name: "SelectProperty",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 727, col: 34, offset: 27404},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 727, col: 37, offset: 27407},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 727, col: 40, offset: 27410},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 727, col: 43, offset: 27413},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 727, col: 47, offset: 27417},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 727, col: 50, offset: 27420},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 727, col: 54, offset: 27424},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 727, col: 65, offset: 27435},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 727, col: 72, offset: 27442},
										expr: &actionExpr{
											pos: position{line: 727, col: 73, offset: 27443},
											run: (*parser).callonInFunction15,
											expr: &seqExpr{
												pos: position{line: 727, col: 73, offset: 27443},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 727, col: 73, offset: 27443},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 727, col: 76, offset: 27446},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 727, col: 80, offset: 27450},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 727, col: 83, offset: 27453},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 727, col: 86, offset: 27456},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 727, col: 118, offset: 27488},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 727, col: 121, offset: 27491},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 729, col: 5, offset: 27615},
						run: (*parser).callonInFunction24,
						expr: &seqExpr{
							pos: position{line: 729, col: 5, offset: 27615},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 729, col: 5, offset: 27615},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 9, offset: 27619},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 729, col: 12, offset: 27622},
									label: "ex1",
									expr: &ruleRefExpr{
										pos:  position{line: 729, col: 16, offset: 27626},
										name: "SelectItem",
									},
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 27, offset: 27637},
									name: "ws",
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 30, offset: 27640},
									name: "In",
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 33, offset: 27643},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 729, col: 36, offset: 27646},
									val:        "(",
									ignoreCase: false,
									want:       "\"(\"",
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 40, offset: 27650},
									name: "ws",
								},
								&labeledExpr{
									pos:   position{line: 729, col: 43, offset: 27653},
									label: "ex2",
									expr: &ruleRefExpr{
										pos:  position{line: 729, col: 47, offset: 27657},
										name: "SelectItem",
									},
								},
								&labeledExpr{
									pos:   position{line: 729, col: 58, offset: 27668},
									label: "others",
									expr: &zeroOrMoreExpr{
										pos: position{line: 729, col: 65, offset: 27675},
										expr: &actionExpr{
											pos: position{line: 729, col: 66, offset: 27676},
											run: (*parser).callonInFunction39,
											expr: &seqExpr{
												pos: position{line: 729, col: 66, offset: 27676},
												exprs: []any{
													&ruleRefExpr{
														pos:  position{line: 729, col: 66, offset: 27676},
														name: "ws",
													},
													&litMatcher{
														pos:        position{line: 729, col: 69, offset: 27679},
														val:        ",",
														ignoreCase: false,
														want:       "\",\"",
													},
													&ruleRefExpr{
														pos:  position{line: 729, col: 73, offset: 27683},
														name: "ws",
													},
													&labeledExpr{
														pos:   position{line: 729, col: 76, offset: 27686},
														label: "ex",
														expr: &ruleRefExpr{
															pos:  position{line: 729, col: 79, offset: 27689},
															name: "SelectItem",
														},
													},
												},
											},
										},
									},
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 111, offset: 27721},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 729, col: 114, offset: 27724},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
								&ruleRefExpr{
									pos:  position{line: 729, col: 118, offset: 27728},
									name: "ws",
								},
								&litMatcher{
									pos:        position{line: 729, col: 121, offset: 27731},
									val:        ")",
									ignoreCase: false,
									want:       "\")\"",
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AvgAggregateExpression",
			pos:  position{line: 733, col: 1, offset: 27854},
			expr: &actionExpr{
				pos: position{line: 733, col: 29, offset: 27882},
				run: (*parser).callonAvgAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 733, col: 29, offset: 27882},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 733, col: 29, offset: 27882},
							val:        "avg",
							ignoreCase: true,
							want:       "\"AVG\"i",
						},
						&litMatcher{
							pos:        position{line: 733, col: 36, offset: 27889},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 40, offset: 27893},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 733, col: 43, offset: 27896},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 733, col: 46, offset: 27899},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 733, col: 58, offset: 27911},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 733, col: 61, offset: 27914},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "CountAggregateExpression",
			pos:  position{line: 737, col: 1, offset: 28006},
			expr: &actionExpr{
				pos: position{line: 737, col: 29, offset: 28034},
				run: (*parser).callonCountAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 737, col: 29, offset: 28034},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 737, col: 29, offset: 28034},
							val:        "count",
							ignoreCase: true,
							want:       "\"COUNT\"i",
						},
						&litMatcher{
							pos:        position{line: 737, col: 38, offset: 28043},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 42, offset: 28047},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 737, col: 45, offset: 28050},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 737, col: 48, offset: 28053},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 737, col: 59, offset: 28064},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 737, col: 62, offset: 28067},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MaxAggregateExpression",
			pos:  position{line: 741, col: 1, offset: 28161},
			expr: &actionExpr{
				pos: position{line: 741, col: 29, offset: 28189},
				run: (*parser).callonMaxAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 741, col: 29, offset: 28189},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 741, col: 29, offset: 28189},
							val:        "max",
							ignoreCase: true,
							want:       "\"MAX\"i",
						},
						&litMatcher{
							pos:        position{line: 741, col: 36, offset: 28196},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 741, col: 40, offset: 28200},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 741, col: 43, offset: 28203},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 741, col: 46, offset: 28206},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 741, col: 57, offset: 28217},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 741, col: 60, offset: 28220},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "MinAggregateExpression",
			pos:  position{line: 745, col: 1, offset: 28312},
			expr: &actionExpr{
				pos: position{line: 745, col: 29, offset: 28340},
				run: (*parser).callonMinAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 745, col: 29, offset: 28340},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 745, col: 29, offset: 28340},
							val:        "min",
							ignoreCase: true,
							want:       "\"MIN\"i",
						},
						&litMatcher{
							pos:        position{line: 745, col: 36, offset: 28347},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 40, offset: 28351},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 745, col: 43, offset: 28354},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 745, col: 46, offset: 28357},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 745, col: 57, offset: 28368},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 745, col: 60, offset: 28371},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "SumAggregateExpression",
			pos:  position{line: 749, col: 1, offset: 28463},
			expr: &actionExpr{
				pos: position{line: 749, col: 29, offset: 28491},
				run: (*parser).callonSumAggregateExpression1,
				expr: &seqExpr{
					pos: position{line: 749, col: 29, offset: 28491},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 749, col: 29, offset: 28491},
							val:        "sum",
							ignoreCase: true,
							want:       "\"SUM\"i",
						},
						&litMatcher{
							pos:        position{line: 749, col: 36, offset: 28498},
							val:        "(",
							ignoreCase: false,
							want:       "\"(\"",
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 40, offset: 28502},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 749, col: 43, offset: 28505},
							label: "ex",
							expr: &ruleRefExpr{
								pos:  position{line: 749, col: 46, offset: 28508},
								name: "SelectItem",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 749, col: 57, offset: 28519},
							name: "ws",
						},
						&litMatcher{
							pos:        position{line: 749, col: 60, offset: 28522},
							val:        ")",
							ignoreCase: false,
							want:       "\")\"",
						},
					},
				},
			},
		},
		{
			name: "Integer",
			pos:  position{line: 753, col: 1, offset: 28614},
			expr: &actionExpr{
				pos: position{line: 753, col: 12, offset: 28625},
				run: (*parser).callonInteger1,
				expr: &oneOrMoreExpr{
					pos: position{line: 753, col: 12, offset: 28625},
					expr: &charClassMatcher{
						pos:        position{line: 753, col: 12, offset: 28625},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 757, col: 1, offset: 28677},
			expr: &choiceExpr{
				pos: position{line: 757, col: 20, offset: 28696},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 757, col: 20, offset: 28696},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 757, col: 20, offset: 28696},
							exprs: []any{
								&notExpr{
									pos: position{line: 757, col: 20, offset: 28696},
									expr: &choiceExpr{
										pos: position{line: 757, col: 22, offset: 28698},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 757, col: 22, offset: 28698},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 757, col: 28, offset: 28704},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 757, col: 34, offset: 28710,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 758, col: 5, offset: 28747},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 758, col: 5, offset: 28747},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 758, col: 5, offset: 28747},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 758, col: 10, offset: 28752},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 758, col: 14, offset: 28756},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 760, col: 1, offset: 28801},
			expr: &labeledExpr{
				pos:   position{line: 760, col: 28, offset: 28828},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 760, col: 33, offset: 28833},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 762, col: 1, offset: 28850},
			expr: &choiceExpr{
				pos: position{line: 762, col: 20, offset: 28869},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 762, col: 20, offset: 28869},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 763, col: 5, offset: 28877},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 764, col: 5, offset: 28885},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 765, col: 5, offset: 28894},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 765, col: 5, offset: 28894},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 766, col: 5, offset: 28923},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 766, col: 5, offset: 28923},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 767, col: 5, offset: 28952},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 767, col: 5, offset: 28952},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 768, col: 5, offset: 28981},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 768, col: 5, offset: 28981},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 769, col: 5, offset: 29010},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 769, col: 5, offset: 29010},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 771, col: 1, offset: 29036},
			expr: &actionExpr{
				pos: position{line: 771, col: 25, offset: 29060},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 771, col: 25, offset: 29060},
					exprs: []any{
						&notExpr{
							pos: position{line: 771, col: 25, offset: 29060},
							expr: &ruleRefExpr{
								pos:  position{line: 771, col: 27, offset: 29062},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 771, col: 45, offset: 29080},
							label: "char",
							expr: &anyMatcher{
								line: 771, col: 50, offset: 29085,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 774, col: 1, offset: 29124},
			expr: &zeroOrMoreExpr{
				pos: position{line: 774, col: 7, offset: 29130},
				expr: &charClassMatcher{
					pos:        position{line: 774, col: 7, offset: 29130},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "wss",
			pos:  position{line: 776, col: 1, offset: 29142},
			expr: &oneOrMoreExpr{
				pos: position{line: 776, col: 8, offset: 29149},
				expr: &charClassMatcher{
					pos:        position{line: 776, col: 8, offset: 29149},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 778, col: 1, offset: 29161},
			expr: &notExpr{
				pos: position{line: 778, col: 8, offset: 29168},
				expr: &anyMatcher{
					line: 778, col: 9, offset: 29169,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt22(join any) (any, error) {
	return join, nil
}

func (p *parser) callonSelectStmt22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt22(stack["join"])
}

func (c *current) onSelectStmt30(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt30() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt30(stack["condition"])
}

func (c *current) onSelectStmt39(columns any) (any, error) {
	return columns, nil
}

func (p *parser) callonSelectStmt39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt39(stack["columns"])
}

func (c *current) onSelectStmt48(order any) (any, error) {
	return order, nil
}

func (p *parser) callonSelectStmt48() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt48(stack["order"])
}

func (c *current) onSelectStmt55(offset any) (any, error) {
	return offset, nil
}

func (p *parser) callonSelectStmt55() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt55(stack["offset"])
}

func (c *current) onSelectStmt1(distinctClause, topClause, columns, fromClause, joinClauses, whereClause, groupByClause, orderByClause, offsetClause any) (any, error) {
	return makeSelectStmt(columns, fromClause, joinClauses, whereClause,
		distinctClause, topClause, groupByClause, orderByClause, offsetClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["distinctClause"], stack["topClause"], stack["columns"], stack["fromClause"], stack["joinClauses"], stack["whereClause"], stack["groupByClause"], stack["orderByClause"], stack["offsetClause"])
}

func (c *current) onTopClause1(count any) (any, error) {
	return count, nil
}

func (p *parser) callonTopClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTopClause1(stack["count"])
}

func (c *current) onFromClause9(column any) (any, error) {
	return column, nil
}

func (p *parser) callonFromClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause9(stack["column"])
}

func (c *current) onFromClause2(table, selectItem any) (any, error) {
	tableTyped := table.(parsers.Table)

	if selectItem != nil {
		tableTyped.SelectItem = selectItem.(parsers.SelectItem)
		tableTyped.IsInSelect = true
	}

	return tableTyped, nil
}

func (p *parser) callonFromClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause2(stack["table"], stack["selectItem"])
}

func (c *current) onFromClause16(column any) (any, error) {
	tableSelectItem := column.(parsers.SelectItem)
	table := parsers.Table{
		Value:      tableSelectItem.Alias,
		SelectItem: tableSelectItem,
	}
	return table, nil
}

func (p *parser) callonFromClause16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause16(stack["column"])
}

func (c *current) onFromClause22(subQuery any) (any, error) {
	subQueryTyped := subQuery.(parsers.SelectItem)
	table := parsers.Table{
		Value:      subQueryTyped.Alias,
		SelectItem: subQueryTyped,
	}
	return table, nil
}

func (p *parser) callonFromClause22() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFromClause22(stack["subQuery"])
}

func (c *current) onSubQuery5(exists any) (any, error) {
	return exists, nil
}

func (p *parser) callonSubQuery5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery5(stack["exists"])
}

func (c *current) onSubQuery1(exists, selectStmt any) (any, error) {
	if selectStatement, isGoodValue := selectStmt.(parsers.SelectStmt); isGoodValue {
		selectStatement.Exists = exists != nil
		return selectStatement, nil
	}

	return selectStmt, nil
}

func (p *parser) callonSubQuery1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuery1(stack["exists"], stack["selectStmt"])
}

func (c *current) onSubQuerySelectItem7(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonSubQuerySelectItem7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem7(stack["alias"])
}

func (c *current) onSubQuerySelectItem1(subQuery, asClause any) (any, error) {
	selectItem := parsers.SelectItem{
		Type:  parsers.SelectItemTypeSubQuery,
		Value: subQuery,
	}

	if tableName, isString := asClause.(string); isString {
		selectItem.Alias = tableName
	}

	return selectItem, nil
}

func (p *parser) callonSubQuerySelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubQuerySelectItem1(stack["subQuery"], stack["asClause"])
}

func (c *current) onJoinClause2(table, column any) (any, error) {
	return makeJoin(table, column)
}

func (p *parser) callonJoinClause2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause2(stack["table"], stack["column"])
}

func (c *current) onJoinClause13(subQuery any) (any, error) {
	return makeJoin(nil, subQuery)
}

func (p *parser) callonJoinClause13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onJoinClause13(stack["subQuery"])
}

func (c *current) onOffsetClause1(offset, limit any) (any, error) {
	return []interface{}{offset.(parsers.Constant).Value, limit.(parsers.Constant).Value}, nil
}

func (p *parser) callonOffsetClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOffsetClause1(stack["offset"], stack["limit"])
}

func (c *current) onSelectAsterisk1() (any, error) {
	selectItem, _ := makeSelectItem("c", make([]interface{}, 0), parsers.SelectItemTypeField)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectAsterisk1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectAsterisk1()
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onSelectValueSpec1(column any) (any, error) {
	selectItem := column.(parsers.SelectItem)
	selectItem.IsTopLevel = true
	return makeColumnList(selectItem, make([]interface{}, 0))
}

func (p *parser) callonSelectValueSpec1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectValueSpec1(stack["column"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onSelectArray1(columns any) (any, error) {
	return makeSelectArray(columns)
}

func (p *parser) callonSelectArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectArray1(stack["columns"])
}

func (c *current) onSelectObject10(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonSelectObject10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject10(stack["coll"])
}

func (c *current) onSelectObject1(field, other_fields any) (any, error) {
	return makeSelectObject(field, other_fields)
}

func (p *parser) callonSelectObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObject1(stack["field"], stack["other_fields"])
}

func (c *current) onSelectObjectField6(key any) (any, error) {
	return key, nil
}

func (p *parser) callonSelectObjectField6() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField6(stack["key"])
}

func (c *current) onSelectObjectField1(name, selectItem any) (any, error) {
	item := selectItem.(parsers.SelectItem)
	item.Alias = name.(string)
	return item, nil
}

func (p *parser) callonSelectObjectField1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectObjectField1(stack["name"], stack["selectItem"])
}

func (c *current) onSelectProperty1(name, path any) (any, error) {
	return makeSelectItem(name, path, parsers.SelectItemTypeField)
}

func (p *parser) callonSelectProperty1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectProperty1(stack["name"], stack["path"])
}

func (c *current) onSelectItem1(selectItem, asClause any) (any, error) {
	var itemResult parsers.SelectItem
	switch typedValue := selectItem.(type) {
	case parsers.SelectItem:
		itemResult = typedValue
	case parsers.Constant:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeConstant,
			Value: typedValue,
		}
	case parsers.FunctionCall:
		itemResult = parsers.SelectItem{
			Type:  parsers.SelectItemTypeFunctionCall,
			Value: typedValue,
		}
	}

	if aliasValue, ok := asClause.(string); ok {
		itemResult.Alias = aliasValue
	}

	return itemResult, nil
}

func (p *parser) callonSelectItem1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectItem1(stack["selectItem"], stack["asClause"])
}

func (c *current) onAsClause1(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonAsClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAsClause1(stack["alias"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess2(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess2(stack["id"])
}

func (c *current) onArrayFieldAccess8(id any) (any, error) {
	return strconv.Itoa(id.(int)), nil
}

func (p *parser) callonArrayFieldAccess8() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess8(stack["id"])
}

func (c *current) onArrayFieldAccess14(id any) (any, error) {
	return id.(parsers.Constant).Value.(string), nil
}

func (p *parser) callonArrayFieldAccess14() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess14(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression2(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression2(stack["ex"])
}

func (c *current) onComparisonExpression10(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: op.(string)}, nil
}

func (p *parser) callonComparisonExpression10() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression10(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonExpression20(inv, ex any) (any, error) {
	if inv != nil {
		ex1 := ex.(parsers.SelectItem)
		ex1.Invert = true
		return ex1, nil
	}
	return ex, nil
}

func (p *parser) callonComparisonExpression20() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression20(stack["inv"], stack["ex"])
}

func (c *current) onComparisonExpression29(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonComparisonExpression29() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression29(stack["ex"])
}

func (c *current) onOrderByClause9(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrderByClause9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause9(stack["ex"])
}

func (c *current) onOrderByClause1(ex1, others any) (any, error) {
	return makeOrderByClause(ex1, others)
}

func (p *parser) callonOrderByClause1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderByClause1(stack["ex1"], stack["others"])
}

func (c *current) onOrderExpression1(field, order any) (any, error) {
	return makeOrderExpression(field, order)
}

func (p *parser) callonOrderExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderExpression1(stack["field"], stack["order"])
}

func (c *current) onOrderDirection1() (any, error) {
	if strings.EqualFold(string(c.text), "DESC") {
		return parsers.OrderDirectionDesc, nil
	}

	return parsers.OrderDirectionAsc, nil
}

func (p *parser) callonOrderDirection1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrderDirection1()
}

func (c *current) onComparisonOperator1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator1()
}

func (c *current) onParameterConstant1() (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeParameterConstant, Value: string(c.text)}, nil
}

func (p *parser) callonParameterConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onParameterConstant1()
}

func (c *current) onNullConstant1() (any, error) {
	return parsers.Constant{Value: nil}, nil
}

func (p *parser) callonNullConstant1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onNullConstant1()
}

func (c *current) onIntegerLiteral1(number any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: number.(int)}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1(stack["number"])
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onUpperExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallUpper, []interface{}{ex})
}

func (p *parser) callonUpperExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onUpperExpression1(stack["ex"])
}

func (c *current) onLowerExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLower, []interface{}{ex})
}

func (p *parser) callonLowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLowerExpression1(stack["ex"])
}

func (c *current) onStringEqualsExpression17(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonStringEqualsExpression17() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression17(stack["boolean"])
}

func (c *current) onStringEqualsExpression1(ex1, ex2, ignoreCase any) (any, error) {
	return createFunctionCall(parsers.FunctionCallStringEquals, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonStringEqualsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringEqualsExpression1(stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onToStringExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallToString, []interface{}{ex})
}

func (p *parser) callonToStringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onToStringExpression1(stack["ex"])
}

func (c *current) onConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression11(stack["ex"])
}

func (c *current) onConcatExpression1(ex1, others any) (any, error) {
	arguments := append([]interface{}{ex1}, others.([]interface{})...)
	return createFunctionCall(parsers.FunctionCallConcat, arguments)
}

func (p *parser) callonConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onConcatExpression1(stack["ex1"], stack["others"])
}

func (c *current) onLeftExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLeft, []interface{}{ex, length})
}

func (p *parser) callonLeftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLeftExpression1(stack["ex"], stack["length"])
}

func (c *current) onLengthExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLength, []interface{}{ex})
}

func (p *parser) callonLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLengthExpression1(stack["ex"])
}

func (c *current) onLTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallLTrim, []interface{}{ex})
}

func (p *parser) callonLTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onLTrimExpression1(stack["ex"])
}

func (c *current) onReplaceExpression1(ex1, ex2, ex3 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplace, []interface{}{ex1, ex2, ex3})
}

func (p *parser) callonReplaceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplaceExpression1(stack["ex1"], stack["ex2"], stack["ex3"])
}

func (c *current) onReplicateExpression1(ex1, ex2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReplicate, []interface{}{ex1, ex2})
}

func (p *parser) callonReplicateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReplicateExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onReverseExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallReverse, []interface{}{ex})
}

func (p *parser) callonReverseExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onReverseExpression1(stack["ex"])
}

func (c *current) onRightExpression1(ex, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRight, []interface{}{ex, length})
}

func (p *parser) callonRightExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRightExpression1(stack["ex"], stack["length"])
}

func (c *current) onRTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallRTrim, []interface{}{ex})
}

func (p *parser) callonRTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onRTrimExpression1(stack["ex"])
}

func (c *current) onSubstringExpression1(ex, startPos, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSubstring, []interface{}{ex, startPos, length})
}

func (p *parser) callonSubstringExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSubstringExpression1(stack["ex"], stack["startPos"], stack["length"])
}

func (c *current) onTrimExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallTrim, []interface{}{ex})
}

func (p *parser) callonTrimExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTrimExpression1(stack["ex"])
}

func (c *current) onThreeArgumentStringFunctionExpression18(boolean any) (any, error) {
	return boolean, nil
}

func (p *parser) callonThreeArgumentStringFunctionExpression18() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression18(stack["boolean"])
}

func (c *current) onThreeArgumentStringFunctionExpression1(function, ex1, ex2, ignoreCase any) (any, error) {
	var functionType parsers.FunctionCallType

	lowerFunction := strings.ToUpper(function.(string))
	switch lowerFunction {
	case "CONTAINS":
		functionType = parsers.FunctionCallContains
	case "ENDSWITH":
		functionType = parsers.FunctionCallEndsWith
	case "STARTSWITH":
		functionType = parsers.FunctionCallStartsWith
	case "INDEX_OF":
		functionType = parsers.FunctionCallIndexOf
	}

	return createFunctionCall(functionType, []interface{}{ex1, ex2, ignoreCase})
}

func (p *parser) callonThreeArgumentStringFunctionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunctionExpression1(stack["function"], stack["ex1"], stack["ex2"], stack["ignoreCase"])
}

func (c *current) onThreeArgumentStringFunction1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonThreeArgumentStringFunction1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onThreeArgumentStringFunction1()
}

func (c *current) onIsDefined1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsDefined, []interface{}{ex})
}

func (p *parser) callonIsDefined1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsDefined1(stack["ex"])
}

func (c *current) onIsArray1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsArray, []interface{}{ex})
}

func (p *parser) callonIsArray1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsArray1(stack["ex"])
}

func (c *current) onIsBool1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsBool, []interface{}{ex})
}

func (p *parser) callonIsBool1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsBool1(stack["ex"])
}

func (c *current) onIsFiniteNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsFiniteNumber, []interface{}{ex})
}

func (p *parser) callonIsFiniteNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsFiniteNumber1(stack["ex"])
}

func (c *current) onIsInteger1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsInteger, []interface{}{ex})
}

func (p *parser) callonIsInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsInteger1(stack["ex"])
}

func (c *current) onIsNull1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNull, []interface{}{ex})
}

func (p *parser) callonIsNull1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNull1(stack["ex"])
}

func (c *current) onIsNumber1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsNumber, []interface{}{ex})
}

func (p *parser) callonIsNumber1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsNumber1(stack["ex"])
}

func (c *current) onIsObject1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsObject, []interface{}{ex})
}

func (p *parser) callonIsObject1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsObject1(stack["ex"])
}

func (c *current) onIsPrimitive1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsPrimitive, []interface{}{ex})
}

func (p *parser) callonIsPrimitive1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsPrimitive1(stack["ex"])
}

func (c *current) onIsString1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIsString, []interface{}{ex})
}

func (p *parser) callonIsString1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIsString1(stack["ex"])
}

func (c *current) onArrayConcatExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayConcatExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression11(stack["ex"])
}

func (c *current) onArrayConcatExpression1(arrays, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayConcat, append([]interface{}{arrays}, others.([]interface{})...))
}

func (p *parser) callonArrayConcatExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayConcatExpression1(stack["arrays"], stack["others"])
}

func (c *current) onArrayContainsExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression16(stack["ex"])
}

func (c *current) onArrayContainsExpression1(array, item, partialMatch any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContains, []interface{}{array, item, partialMatch})
}

func (p *parser) callonArrayContainsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsExpression1(stack["array"], stack["item"], stack["partialMatch"])
}

func (c *current) onArrayContainsAnyExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAnyExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression11(stack["ex"])
}

func (c *current) onArrayContainsAnyExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAny, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAnyExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAnyExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayContainsAllExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArrayContainsAllExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression11(stack["ex"])
}

func (c *current) onArrayContainsAllExpression1(array, items any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayContainsAll, append([]interface{}{array}, items.([]interface{})...))
}

func (p *parser) callonArrayContainsAllExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayContainsAllExpression1(stack["array"], stack["items"])
}

func (c *current) onArrayLengthExpression1(array any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArrayLength, []interface{}{array})
}

func (p *parser) callonArrayLengthExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayLengthExpression1(stack["array"])
}

func (c *current) onArraySliceExpression16(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonArraySliceExpression16() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression16(stack["ex"])
}

func (c *current) onArraySliceExpression1(array, start, length any) (any, error) {
	return createFunctionCall(parsers.FunctionCallArraySlice, []interface{}{array, start, length})
}

func (p *parser) callonArraySliceExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArraySliceExpression1(stack["array"], stack["start"], stack["length"])
}

func (c *current) onSetIntersectExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetIntersect, []interface{}{set1, set2})
}

func (p *parser) callonSetIntersectExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetIntersectExpression1(stack["set1"], stack["set2"])
}

func (c *current) onSetUnionExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallSetUnion, []interface{}{set1, set2})
}

func (p *parser) callonSetUnionExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSetUnionExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathAbsExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAbs, []interface{}{ex})
}

func (p *parser) callonMathAbsExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAbsExpression1(stack["ex"])
}

func (c *current) onMathAcosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAcos, []interface{}{ex})
}

func (p *parser) callonMathAcosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAcosExpression1(stack["ex"])
}

func (c *current) onMathAsinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAsin, []interface{}{ex})
}

func (p *parser) callonMathAsinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAsinExpression1(stack["ex"])
}

func (c *current) onMathAtanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtan, []interface{}{ex})
}

func (p *parser) callonMathAtanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtanExpression1(stack["ex"])
}

func (c *current) onMathCeilingExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCeiling, []interface{}{ex})
}

func (p *parser) callonMathCeilingExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCeilingExpression1(stack["ex"])
}

func (c *current) onMathCosExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCos, []interface{}{ex})
}

func (p *parser) callonMathCosExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCosExpression1(stack["ex"])
}

func (c *current) onMathCotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathCot, []interface{}{ex})
}

func (p *parser) callonMathCotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathCotExpression1(stack["ex"])
}

func (c *current) onMathDegreesExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathDegrees, []interface{}{ex})
}

func (p *parser) callonMathDegreesExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathDegreesExpression1(stack["ex"])
}

func (c *current) onMathExpExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathExp, []interface{}{ex})
}

func (p *parser) callonMathExpExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathExpExpression1(stack["ex"])
}

func (c *current) onMathFloorExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathFloor, []interface{}{ex})
}

func (p *parser) callonMathFloorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathFloorExpression1(stack["ex"])
}

func (c *current) onMathIntBitNotExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitNot, []interface{}{ex})
}

func (p *parser) callonMathIntBitNotExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitNotExpression1(stack["ex"])
}

func (c *current) onMathLog10Expression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog10, []interface{}{ex})
}

func (p *parser) callonMathLog10Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLog10Expression1(stack["ex"])
}

func (c *current) onMathRadiansExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRadians, []interface{}{ex})
}

func (p *parser) callonMathRadiansExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRadiansExpression1(stack["ex"])
}

func (c *current) onMathRoundExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRound, []interface{}{ex})
}

func (p *parser) callonMathRoundExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRoundExpression1(stack["ex"])
}

func (c *current) onMathSignExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSign, []interface{}{ex})
}

func (p *parser) callonMathSignExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSignExpression1(stack["ex"])
}

func (c *current) onMathSinExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSin, []interface{}{ex})
}

func (p *parser) callonMathSinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSinExpression1(stack["ex"])
}

func (c *current) onMathSqrtExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSqrt, []interface{}{ex})
}

func (p *parser) callonMathSqrtExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSqrtExpression1(stack["ex"])
}

func (c *current) onMathSquareExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathSquare, []interface{}{ex})
}

func (p *parser) callonMathSquareExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathSquareExpression1(stack["ex"])
}

func (c *current) onMathTanExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTan, []interface{}{ex})
}

func (p *parser) callonMathTanExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTanExpression1(stack["ex"])
}

func (c *current) onMathTruncExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathTrunc, []interface{}{ex})
}

func (p *parser) callonMathTruncExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathTruncExpression1(stack["ex"])
}

func (c *current) onMathAtn2Expression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathAtn2, []interface{}{set1, set2})
}

func (p *parser) callonMathAtn2Expression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathAtn2Expression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntAddExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntAdd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntAddExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntAddExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitAndExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitAnd, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitAndExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitLeftShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitLeftShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitLeftShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitLeftShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitOrExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitOr, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitOrExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitRightShiftExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitRightShift, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitRightShiftExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitRightShiftExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntBitXorExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntBitXor, []interface{}{set1, set2})
}

func (p *parser) callonMathIntBitXorExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntBitXorExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntDivExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntDiv, []interface{}{set1, set2})
}

func (p *parser) callonMathIntDivExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntDivExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntModExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMod, []interface{}{set1, set2})
}

func (p *parser) callonMathIntModExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntModExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntMulExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntMul, []interface{}{set1, set2})
}

func (p *parser) callonMathIntMulExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntMulExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathIntSubExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathIntSub, []interface{}{set1, set2})
}

func (p *parser) callonMathIntSubExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathIntSubExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathPowerExpression1(set1, set2 any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPower, []interface{}{set1, set2})
}

func (p *parser) callonMathPowerExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPowerExpression1(stack["set1"], stack["set2"])
}

func (c *current) onMathLogExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathLogExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression11(stack["ex"])
}

func (c *current) onMathLogExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathLog, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathLogExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathLogExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathNumberBinExpression11(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonMathNumberBinExpression11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression11(stack["ex"])
}

func (c *current) onMathNumberBinExpression1(ex1, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallMathNumberBin, append([]interface{}{ex1}, others.([]interface{})...))
}

func (p *parser) callonMathNumberBinExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathNumberBinExpression1(stack["ex1"], stack["others"])
}

func (c *current) onMathPiExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathPi, []interface{}{})
}

func (p *parser) callonMathPiExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathPiExpression1()
}

func (c *current) onMathRandExpression1() (any, error) {
	return createFunctionCall(parsers.FunctionCallMathRand, []interface{}{})
}

func (p *parser) callonMathRandExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMathRandExpression1()
}

func (c *current) onInFunction15(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction15() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction15(stack["ex"])
}

func (c *current) onInFunction2(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction2(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onInFunction39(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonInFunction39() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction39(stack["ex"])
}

func (c *current) onInFunction24(ex1, ex2, others any) (any, error) {
	return createFunctionCall(parsers.FunctionCallIn, append([]interface{}{ex1, ex2}, others.([]interface{})...))
}

func (p *parser) callonInFunction24() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInFunction24(stack["ex1"], stack["ex2"], stack["others"])
}

func (c *current) onAvgAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateAvg, []interface{}{ex})
}

func (p *parser) callonAvgAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAvgAggregateExpression1(stack["ex"])
}

func (c *current) onCountAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateCount, []interface{}{ex})
}

func (p *parser) callonCountAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCountAggregateExpression1(stack["ex"])
}

func (c *current) onMaxAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMax, []interface{}{ex})
}

func (p *parser) callonMaxAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMaxAggregateExpression1(stack["ex"])
}

func (c *current) onMinAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateMin, []interface{}{ex})
}

func (p *parser) callonMinAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onMinAggregateExpression1(stack["ex"])
}

func (c *current) onSumAggregateExpression1(ex any) (any, error) {
	return createFunctionCall(parsers.FunctionCallAggregateSum, []interface{}{ex})
}

func (p *parser) callonSumAggregateExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSumAggregateExpression1(stack["ex"])
}

func (c *current) onInteger1() (any, error) {
	return strconv.Atoi(string(c.text))
}

func (p *parser) callonInteger1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInteger1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
